/*
 * Copyright © 2015 Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

/* This file generated from lvp_entrypoints_gen.py, don't edit directly. */

#include "lvp_private.h"

#include "util/macros.h"
struct string_map_entry {
   uint32_t name;
   uint32_t hash;
   uint32_t num;
};

/* We use a big string constant to avoid lots of relocations from the entry
 * point table to lots of little strings. The entries in the entry point table
 * store the index into this big string.
 */




static const char instance_strings[] =
    "vkCreateDebugReportCallbackEXT\0"
    "vkCreateDisplayPlaneSurfaceKHR\0"
    "vkCreateInstance\0"
    "vkCreateWaylandSurfaceKHR\0"
    "vkCreateXcbSurfaceKHR\0"
    "vkCreateXlibSurfaceKHR\0"
    "vkDebugReportMessageEXT\0"
    "vkDestroyDebugReportCallbackEXT\0"
    "vkDestroyInstance\0"
    "vkDestroySurfaceKHR\0"
    "vkEnumerateInstanceExtensionProperties\0"
    "vkEnumerateInstanceLayerProperties\0"
    "vkEnumerateInstanceVersion\0"
    "vkEnumeratePhysicalDeviceGroups\0"
    "vkEnumeratePhysicalDeviceGroupsKHR\0"
    "vkEnumeratePhysicalDevices\0"
    "vkGetInstanceProcAddr\0"
;

static const struct string_map_entry instance_string_map_entries[] = {
    { 0, 0x987ef56, 12 }, /* vkCreateDebugReportCallbackEXT */
    { 31, 0x7ac4dacb, 7 }, /* vkCreateDisplayPlaneSurfaceKHR */
    { 62, 0x38a581a6, 0 }, /* vkCreateInstance */
    { 79, 0x2b2a4b79, 9 }, /* vkCreateWaylandSurfaceKHR */
    { 105, 0xc5e5b106, 11 }, /* vkCreateXcbSurfaceKHR */
    { 127, 0xa693bc66, 10 }, /* vkCreateXlibSurfaceKHR */
    { 150, 0xa4e75334, 14 }, /* vkDebugReportMessageEXT */
    { 174, 0x43d4c4e2, 13 }, /* vkDestroyDebugReportCallbackEXT */
    { 206, 0x9bd21af2, 1 }, /* vkDestroyInstance */
    { 224, 0xf204ce7d, 8 }, /* vkDestroySurfaceKHR */
    { 244, 0xeb27627e, 6 }, /* vkEnumerateInstanceExtensionProperties */
    { 283, 0x81f69d8, 5 }, /* vkEnumerateInstanceLayerProperties */
    { 318, 0xd0481e5c, 4 }, /* vkEnumerateInstanceVersion */
    { 345, 0x270514f0, 15 }, /* vkEnumeratePhysicalDeviceGroups */
    { 377, 0x549ce595, 16 }, /* vkEnumeratePhysicalDeviceGroupsKHR */
    { 412, 0x5787c327, 2 }, /* vkEnumeratePhysicalDevices */
    { 439, 0x3d2ae9ad, 3 }, /* vkGetInstanceProcAddr */
};

/* Hash table stats:
 * size 17 entries
 * collisions entries:
 *     0      15
 *     1      0
 *     2      1
 *     3      1
 *     4      0
 *     5      0
 *     6      0
 *     7      0
 *     8      0
 *     9+     0
 */

#define none 0xffff
static const uint16_t instance_string_map[32] = {
    none,
    none,
    0x0007,
    none,
    none,
    none,
    0x0002,
    0x000f,
    none,
    none,
    none,
    0x0001,
    0x0004,
    0x0010,
    none,
    none,
    0x000d,
    none,
    0x0008,
    none,
    0x0006,
    0x000e,
    0x0000,
    none,
    0x000b,
    0x0003,
    none,
    none,
    0x000c,
    0x0009,
    0x000a,
    0x0005,
};

static int
instance_string_map_lookup(const char *str)
{
    static const uint32_t prime_factor = 5024183;
    static const uint32_t prime_step = 19;
    const struct string_map_entry *e;
    uint32_t hash, h;
    uint16_t i;
    const char *p;

    hash = 0;
    for (p = str; *p; p++)
        hash = hash * prime_factor + *p;

    h = hash;
    while (1) {
        i = instance_string_map[h & 31];
        if (i == none)
           return -1;
        e = &instance_string_map_entries[i];
        if (e->hash == hash && strcmp(str, instance_strings + e->name) == 0)
            return e->num;
        h += prime_step;
    }

    return -1;
}

static const char *
instance_entry_name(int num)
{
   for (int i = 0; i < ARRAY_SIZE(instance_string_map_entries); i++) {
      if (instance_string_map_entries[i].num == num)
         return &instance_strings[instance_string_map_entries[i].name];
   }
   return NULL;
}


static const char physical_device_strings[] =
    "vkAcquireXlibDisplayEXT\0"
    "vkCreateDevice\0"
    "vkCreateDisplayModeKHR\0"
    "vkEnumerateDeviceExtensionProperties\0"
    "vkEnumerateDeviceLayerProperties\0"
    "vkGetDisplayModeProperties2KHR\0"
    "vkGetDisplayModePropertiesKHR\0"
    "vkGetDisplayPlaneCapabilities2KHR\0"
    "vkGetDisplayPlaneCapabilitiesKHR\0"
    "vkGetDisplayPlaneSupportedDisplaysKHR\0"
    "vkGetPhysicalDeviceCalibrateableTimeDomainsEXT\0"
    "vkGetPhysicalDeviceDisplayPlaneProperties2KHR\0"
    "vkGetPhysicalDeviceDisplayPlanePropertiesKHR\0"
    "vkGetPhysicalDeviceDisplayProperties2KHR\0"
    "vkGetPhysicalDeviceDisplayPropertiesKHR\0"
    "vkGetPhysicalDeviceExternalBufferProperties\0"
    "vkGetPhysicalDeviceExternalBufferPropertiesKHR\0"
    "vkGetPhysicalDeviceExternalFenceProperties\0"
    "vkGetPhysicalDeviceExternalFencePropertiesKHR\0"
    "vkGetPhysicalDeviceExternalSemaphoreProperties\0"
    "vkGetPhysicalDeviceExternalSemaphorePropertiesKHR\0"
    "vkGetPhysicalDeviceFeatures\0"
    "vkGetPhysicalDeviceFeatures2\0"
    "vkGetPhysicalDeviceFeatures2KHR\0"
    "vkGetPhysicalDeviceFormatProperties\0"
    "vkGetPhysicalDeviceFormatProperties2\0"
    "vkGetPhysicalDeviceFormatProperties2KHR\0"
    "vkGetPhysicalDeviceImageFormatProperties\0"
    "vkGetPhysicalDeviceImageFormatProperties2\0"
    "vkGetPhysicalDeviceImageFormatProperties2KHR\0"
    "vkGetPhysicalDeviceMemoryProperties\0"
    "vkGetPhysicalDeviceMemoryProperties2\0"
    "vkGetPhysicalDeviceMemoryProperties2KHR\0"
    "vkGetPhysicalDeviceMultisamplePropertiesEXT\0"
    "vkGetPhysicalDevicePresentRectanglesKHR\0"
    "vkGetPhysicalDeviceProperties\0"
    "vkGetPhysicalDeviceProperties2\0"
    "vkGetPhysicalDeviceProperties2KHR\0"
    "vkGetPhysicalDeviceQueueFamilyProperties\0"
    "vkGetPhysicalDeviceQueueFamilyProperties2\0"
    "vkGetPhysicalDeviceQueueFamilyProperties2KHR\0"
    "vkGetPhysicalDeviceSparseImageFormatProperties\0"
    "vkGetPhysicalDeviceSparseImageFormatProperties2\0"
    "vkGetPhysicalDeviceSparseImageFormatProperties2KHR\0"
    "vkGetPhysicalDeviceSurfaceCapabilities2EXT\0"
    "vkGetPhysicalDeviceSurfaceCapabilities2KHR\0"
    "vkGetPhysicalDeviceSurfaceCapabilitiesKHR\0"
    "vkGetPhysicalDeviceSurfaceFormats2KHR\0"
    "vkGetPhysicalDeviceSurfaceFormatsKHR\0"
    "vkGetPhysicalDeviceSurfacePresentModesKHR\0"
    "vkGetPhysicalDeviceSurfaceSupportKHR\0"
    "vkGetPhysicalDeviceWaylandPresentationSupportKHR\0"
    "vkGetPhysicalDeviceXcbPresentationSupportKHR\0"
    "vkGetPhysicalDeviceXlibPresentationSupportKHR\0"
    "vkGetRandROutputDisplayEXT\0"
    "vkReleaseDisplayEXT\0"
;

static const struct string_map_entry physical_device_string_map_entries[] = {
    { 0, 0x60df100d, 44 }, /* vkAcquireXlibDisplayEXT */
    { 24, 0x85ed23f, 6 }, /* vkCreateDevice */
    { 39, 0xcc0bde41, 14 }, /* vkCreateDisplayModeKHR */
    { 62, 0x5fd13eed, 8 }, /* vkEnumerateDeviceExtensionProperties */
    { 99, 0x2f8566e7, 7 }, /* vkEnumerateDeviceLayerProperties */
    { 132, 0x3e613e42, 53 }, /* vkGetDisplayModeProperties2KHR */
    { 163, 0x36b8a8de, 13 }, /* vkGetDisplayModePropertiesKHR */
    { 193, 0xff1655a4, 54 }, /* vkGetDisplayPlaneCapabilities2KHR */
    { 227, 0x4b60d48c, 15 }, /* vkGetDisplayPlaneCapabilitiesKHR */
    { 260, 0xabef4889, 12 }, /* vkGetDisplayPlaneSupportedDisplaysKHR */
    { 298, 0xea07da1a, 55 }, /* vkGetPhysicalDeviceCalibrateableTimeDomainsEXT */
    { 345, 0xb7bc4386, 52 }, /* vkGetPhysicalDeviceDisplayPlaneProperties2KHR */
    { 391, 0xb9b8ddba, 11 }, /* vkGetPhysicalDeviceDisplayPlanePropertiesKHR */
    { 436, 0x540c0372, 51 }, /* vkGetPhysicalDeviceDisplayProperties2KHR */
    { 477, 0xfa0cd2e, 10 }, /* vkGetPhysicalDeviceDisplayPropertiesKHR */
    { 517, 0x944476dc, 37 }, /* vkGetPhysicalDeviceExternalBufferProperties */
    { 561, 0xee68b389, 38 }, /* vkGetPhysicalDeviceExternalBufferPropertiesKHR */
    { 608, 0x3bc965eb, 41 }, /* vkGetPhysicalDeviceExternalFenceProperties */
    { 651, 0x99b35492, 42 }, /* vkGetPhysicalDeviceExternalFencePropertiesKHR */
    { 697, 0xcf251b0e, 39 }, /* vkGetPhysicalDeviceExternalSemaphoreProperties */
    { 744, 0x984c3fa7, 40 }, /* vkGetPhysicalDeviceExternalSemaphorePropertiesKHR */
    { 794, 0x113e2f33, 3 }, /* vkGetPhysicalDeviceFeatures */
    { 822, 0x63c068a7, 23 }, /* vkGetPhysicalDeviceFeatures2 */
    { 851, 0x6a9a3636, 24 }, /* vkGetPhysicalDeviceFeatures2KHR */
    { 883, 0x3e54b398, 4 }, /* vkGetPhysicalDeviceFormatProperties */
    { 919, 0xca3bb9da, 27 }, /* vkGetPhysicalDeviceFormatProperties2 */
    { 956, 0x9099cbbb, 28 }, /* vkGetPhysicalDeviceFormatProperties2KHR */
    { 996, 0xdd36a867, 5 }, /* vkGetPhysicalDeviceImageFormatProperties */
    { 1037, 0x35d260d3, 29 }, /* vkGetPhysicalDeviceImageFormatProperties2 */
    { 1079, 0x102ff7ea, 30 }, /* vkGetPhysicalDeviceImageFormatProperties2KHR */
    { 1124, 0xa90da4da, 2 }, /* vkGetPhysicalDeviceMemoryProperties */
    { 1160, 0xcb4cc208, 33 }, /* vkGetPhysicalDeviceMemoryProperties2 */
    { 1197, 0xc8c3da3d, 34 }, /* vkGetPhysicalDeviceMemoryProperties2KHR */
    { 1237, 0x219aa0b9, 48 }, /* vkGetPhysicalDeviceMultisamplePropertiesEXT */
    { 1281, 0x100341b4, 47 }, /* vkGetPhysicalDevicePresentRectanglesKHR */
    { 1321, 0x52fe22c9, 0 }, /* vkGetPhysicalDeviceProperties */
    { 1351, 0x6c4d8ee1, 25 }, /* vkGetPhysicalDeviceProperties2 */
    { 1382, 0xcd15838c, 26 }, /* vkGetPhysicalDeviceProperties2KHR */
    { 1416, 0x4e5fc88a, 1 }, /* vkGetPhysicalDeviceQueueFamilyProperties */
    { 1457, 0xcad374d8, 31 }, /* vkGetPhysicalDeviceQueueFamilyProperties2 */
    { 1499, 0x5ceb2bed, 32 }, /* vkGetPhysicalDeviceQueueFamilyProperties2KHR */
    { 1544, 0x272ef8ef, 9 }, /* vkGetPhysicalDeviceSparseImageFormatProperties */
    { 1591, 0xebddba0b, 35 }, /* vkGetPhysicalDeviceSparseImageFormatProperties2 */
    { 1639, 0x8746ed72, 36 }, /* vkGetPhysicalDeviceSparseImageFormatProperties2KHR */
    { 1690, 0x5a5fba04, 46 }, /* vkGetPhysicalDeviceSurfaceCapabilities2EXT */
    { 1733, 0x9497e378, 49 }, /* vkGetPhysicalDeviceSurfaceCapabilities2KHR */
    { 1776, 0x77890558, 17 }, /* vkGetPhysicalDeviceSurfaceCapabilitiesKHR */
    { 1818, 0xd00b7188, 50 }, /* vkGetPhysicalDeviceSurfaceFormats2KHR */
    { 1856, 0xe32227c8, 18 }, /* vkGetPhysicalDeviceSurfaceFormatsKHR */
    { 1893, 0x31c3cbd1, 19 }, /* vkGetPhysicalDeviceSurfacePresentModesKHR */
    { 1935, 0x1a687885, 16 }, /* vkGetPhysicalDeviceSurfaceSupportKHR */
    { 1972, 0x84e085ac, 20 }, /* vkGetPhysicalDeviceWaylandPresentationSupportKHR */
    { 2021, 0x41782cb9, 22 }, /* vkGetPhysicalDeviceXcbPresentationSupportKHR */
    { 2066, 0x34a063ab, 21 }, /* vkGetPhysicalDeviceXlibPresentationSupportKHR */
    { 2112, 0xb87cdd6c, 45 }, /* vkGetRandROutputDisplayEXT */
    { 2139, 0x4207f4f1, 43 }, /* vkReleaseDisplayEXT */
};

/* Hash table stats:
 * size 56 entries
 * collisions entries:
 *     0      44
 *     1      7
 *     2      5
 *     3      0
 *     4      0
 *     5      0
 *     6      0
 *     7      0
 *     8      0
 *     9+     0
 */

#define none 0xffff
static const uint16_t physical_device_string_map[128] = {
    0x001e,
    none,
    none,
    none,
    0x002c,
    0x002b,
    0x000b,
    none,
    0x001f,
    0x0009,
    0x0026,
    0x002a,
    0x0008,
    0x0000,
    0x0013,
    none,
    none,
    none,
    0x0012,
    0x0028,
    none,
    none,
    none,
    none,
    0x0018,
    none,
    0x000a,
    0x002f,
    0x0010,
    none,
    none,
    0x0025,
    none,
    none,
    none,
    none,
    0x0007,
    none,
    none,
    0x0014,
    none,
    none,
    none,
    0x0032,
    0x0033,
    none,
    0x000e,
    none,
    none,
    none,
    none,
    0x0015,
    0x0022,
    none,
    0x0017,
    none,
    none,
    0x0021,
    0x000c,
    0x001a,
    none,
    0x0020,
    0x0035,
    0x0001,
    none,
    0x0002,
    0x0005,
    none,
    none,
    none,
    none,
    none,
    0x0030,
    0x0023,
    none,
    none,
    0x0034,
    0x0016,
    none,
    none,
    none,
    0x0031,
    none,
    0x001c,
    none,
    none,
    none,
    none,
    0x0027,
    none,
    0x0019,
    none,
    0x000f,
    none,
    0x0006,
    none,
    none,
    0x0024,
    none,
    none,
    none,
    none,
    none,
    0x0004,
    none,
    none,
    0x001d,
    0x0011,
    0x0036,
    0x0003,
    none,
    0x0029,
    none,
    0x0037,
    0x000d,
    none,
    none,
    none,
    none,
    none,
    0x002d,
    none,
    0x001b,
    none,
    none,
    none,
    0x002e,
    none,
};

static int
physical_device_string_map_lookup(const char *str)
{
    static const uint32_t prime_factor = 5024183;
    static const uint32_t prime_step = 19;
    const struct string_map_entry *e;
    uint32_t hash, h;
    uint16_t i;
    const char *p;

    hash = 0;
    for (p = str; *p; p++)
        hash = hash * prime_factor + *p;

    h = hash;
    while (1) {
        i = physical_device_string_map[h & 127];
        if (i == none)
           return -1;
        e = &physical_device_string_map_entries[i];
        if (e->hash == hash && strcmp(str, physical_device_strings + e->name) == 0)
            return e->num;
        h += prime_step;
    }

    return -1;
}

static const char *
physical_device_entry_name(int num)
{
   for (int i = 0; i < ARRAY_SIZE(physical_device_string_map_entries); i++) {
      if (physical_device_string_map_entries[i].num == num)
         return &physical_device_strings[physical_device_string_map_entries[i].name];
   }
   return NULL;
}


static const char device_strings[] =
    "vkAcquireImageANDROID\0"
    "vkAcquireNextImage2KHR\0"
    "vkAcquireNextImageKHR\0"
    "vkAllocateCommandBuffers\0"
    "vkAllocateDescriptorSets\0"
    "vkAllocateMemory\0"
    "vkBeginCommandBuffer\0"
    "vkBindBufferMemory\0"
    "vkBindBufferMemory2\0"
    "vkBindBufferMemory2KHR\0"
    "vkBindImageMemory\0"
    "vkBindImageMemory2\0"
    "vkBindImageMemory2KHR\0"
    "vkCmdBeginConditionalRenderingEXT\0"
    "vkCmdBeginQuery\0"
    "vkCmdBeginQueryIndexedEXT\0"
    "vkCmdBeginRenderPass\0"
    "vkCmdBeginRenderPass2\0"
    "vkCmdBeginRenderPass2KHR\0"
    "vkCmdBeginTransformFeedbackEXT\0"
    "vkCmdBindDescriptorSets\0"
    "vkCmdBindIndexBuffer\0"
    "vkCmdBindPipeline\0"
    "vkCmdBindTransformFeedbackBuffersEXT\0"
    "vkCmdBindVertexBuffers\0"
    "vkCmdBlitImage\0"
    "vkCmdClearAttachments\0"
    "vkCmdClearColorImage\0"
    "vkCmdClearDepthStencilImage\0"
    "vkCmdCopyBuffer\0"
    "vkCmdCopyBufferToImage\0"
    "vkCmdCopyImage\0"
    "vkCmdCopyImageToBuffer\0"
    "vkCmdCopyQueryPoolResults\0"
    "vkCmdDispatch\0"
    "vkCmdDispatchBase\0"
    "vkCmdDispatchBaseKHR\0"
    "vkCmdDispatchIndirect\0"
    "vkCmdDraw\0"
    "vkCmdDrawIndexed\0"
    "vkCmdDrawIndexedIndirect\0"
    "vkCmdDrawIndexedIndirectCount\0"
    "vkCmdDrawIndexedIndirectCountKHR\0"
    "vkCmdDrawIndirect\0"
    "vkCmdDrawIndirectByteCountEXT\0"
    "vkCmdDrawIndirectCount\0"
    "vkCmdDrawIndirectCountKHR\0"
    "vkCmdEndConditionalRenderingEXT\0"
    "vkCmdEndQuery\0"
    "vkCmdEndQueryIndexedEXT\0"
    "vkCmdEndRenderPass\0"
    "vkCmdEndRenderPass2\0"
    "vkCmdEndRenderPass2KHR\0"
    "vkCmdEndTransformFeedbackEXT\0"
    "vkCmdExecuteCommands\0"
    "vkCmdFillBuffer\0"
    "vkCmdNextSubpass\0"
    "vkCmdNextSubpass2\0"
    "vkCmdNextSubpass2KHR\0"
    "vkCmdPipelineBarrier\0"
    "vkCmdPushConstants\0"
    "vkCmdPushDescriptorSetKHR\0"
    "vkCmdPushDescriptorSetWithTemplateKHR\0"
    "vkCmdResetEvent\0"
    "vkCmdResetQueryPool\0"
    "vkCmdResolveImage\0"
    "vkCmdSetBlendConstants\0"
    "vkCmdSetDepthBias\0"
    "vkCmdSetDepthBounds\0"
    "vkCmdSetDeviceMask\0"
    "vkCmdSetDeviceMaskKHR\0"
    "vkCmdSetDiscardRectangleEXT\0"
    "vkCmdSetEvent\0"
    "vkCmdSetLineWidth\0"
    "vkCmdSetSampleLocationsEXT\0"
    "vkCmdSetScissor\0"
    "vkCmdSetStencilCompareMask\0"
    "vkCmdSetStencilReference\0"
    "vkCmdSetStencilWriteMask\0"
    "vkCmdSetViewport\0"
    "vkCmdUpdateBuffer\0"
    "vkCmdWaitEvents\0"
    "vkCmdWriteTimestamp\0"
    "vkCreateBuffer\0"
    "vkCreateBufferView\0"
    "vkCreateCommandPool\0"
    "vkCreateComputePipelines\0"
    "vkCreateDescriptorPool\0"
    "vkCreateDescriptorSetLayout\0"
    "vkCreateDescriptorUpdateTemplate\0"
    "vkCreateDescriptorUpdateTemplateKHR\0"
    "vkCreateEvent\0"
    "vkCreateFence\0"
    "vkCreateFramebuffer\0"
    "vkCreateGraphicsPipelines\0"
    "vkCreateImage\0"
    "vkCreateImageView\0"
    "vkCreatePipelineCache\0"
    "vkCreatePipelineLayout\0"
    "vkCreatePrivateDataSlotEXT\0"
    "vkCreateQueryPool\0"
    "vkCreateRenderPass\0"
    "vkCreateRenderPass2\0"
    "vkCreateRenderPass2KHR\0"
    "vkCreateSampler\0"
    "vkCreateSamplerYcbcrConversion\0"
    "vkCreateSamplerYcbcrConversionKHR\0"
    "vkCreateSemaphore\0"
    "vkCreateShaderModule\0"
    "vkCreateSwapchainKHR\0"
    "vkDestroyBuffer\0"
    "vkDestroyBufferView\0"
    "vkDestroyCommandPool\0"
    "vkDestroyDescriptorPool\0"
    "vkDestroyDescriptorSetLayout\0"
    "vkDestroyDescriptorUpdateTemplate\0"
    "vkDestroyDescriptorUpdateTemplateKHR\0"
    "vkDestroyDevice\0"
    "vkDestroyEvent\0"
    "vkDestroyFence\0"
    "vkDestroyFramebuffer\0"
    "vkDestroyImage\0"
    "vkDestroyImageView\0"
    "vkDestroyPipeline\0"
    "vkDestroyPipelineCache\0"
    "vkDestroyPipelineLayout\0"
    "vkDestroyPrivateDataSlotEXT\0"
    "vkDestroyQueryPool\0"
    "vkDestroyRenderPass\0"
    "vkDestroySampler\0"
    "vkDestroySamplerYcbcrConversion\0"
    "vkDestroySamplerYcbcrConversionKHR\0"
    "vkDestroySemaphore\0"
    "vkDestroyShaderModule\0"
    "vkDestroySwapchainKHR\0"
    "vkDeviceWaitIdle\0"
    "vkDisplayPowerControlEXT\0"
    "vkEndCommandBuffer\0"
    "vkFlushMappedMemoryRanges\0"
    "vkFreeCommandBuffers\0"
    "vkFreeDescriptorSets\0"
    "vkFreeMemory\0"
    "vkGetBufferDeviceAddress\0"
    "vkGetBufferDeviceAddressEXT\0"
    "vkGetBufferMemoryRequirements\0"
    "vkGetBufferMemoryRequirements2\0"
    "vkGetBufferMemoryRequirements2KHR\0"
    "vkGetBufferOpaqueCaptureAddress\0"
    "vkGetCalibratedTimestampsEXT\0"
    "vkGetDescriptorSetLayoutSupport\0"
    "vkGetDescriptorSetLayoutSupportKHR\0"
    "vkGetDeviceGroupPeerMemoryFeatures\0"
    "vkGetDeviceGroupPeerMemoryFeaturesKHR\0"
    "vkGetDeviceGroupPresentCapabilitiesKHR\0"
    "vkGetDeviceGroupSurfacePresentModesKHR\0"
    "vkGetDeviceMemoryCommitment\0"
    "vkGetDeviceMemoryOpaqueCaptureAddress\0"
    "vkGetDeviceProcAddr\0"
    "vkGetDeviceQueue\0"
    "vkGetDeviceQueue2\0"
    "vkGetEventStatus\0"
    "vkGetFenceFdKHR\0"
    "vkGetFenceStatus\0"
    "vkGetImageMemoryRequirements\0"
    "vkGetImageMemoryRequirements2\0"
    "vkGetImageMemoryRequirements2KHR\0"
    "vkGetImageSparseMemoryRequirements\0"
    "vkGetImageSparseMemoryRequirements2\0"
    "vkGetImageSparseMemoryRequirements2KHR\0"
    "vkGetImageSubresourceLayout\0"
    "vkGetMemoryFdKHR\0"
    "vkGetMemoryFdPropertiesKHR\0"
    "vkGetMemoryHostPointerPropertiesEXT\0"
    "vkGetPipelineCacheData\0"
    "vkGetPipelineExecutableInternalRepresentationsKHR\0"
    "vkGetPipelineExecutablePropertiesKHR\0"
    "vkGetPipelineExecutableStatisticsKHR\0"
    "vkGetPrivateDataEXT\0"
    "vkGetQueryPoolResults\0"
    "vkGetRayTracingShaderGroupHandlesNV\0"
    "vkGetRenderAreaGranularity\0"
    "vkGetSemaphoreCounterValue\0"
    "vkGetSemaphoreFdKHR\0"
    "vkGetSwapchainCounterEXT\0"
    "vkGetSwapchainGrallocUsage2ANDROID\0"
    "vkGetSwapchainGrallocUsageANDROID\0"
    "vkGetSwapchainImagesKHR\0"
    "vkImportFenceFdKHR\0"
    "vkImportSemaphoreFdKHR\0"
    "vkInvalidateMappedMemoryRanges\0"
    "vkMapMemory\0"
    "vkMergePipelineCaches\0"
    "vkQueueBindSparse\0"
    "vkQueuePresentKHR\0"
    "vkQueueSignalReleaseImageANDROID\0"
    "vkQueueSubmit\0"
    "vkQueueWaitIdle\0"
    "vkRegisterDeviceEventEXT\0"
    "vkRegisterDisplayEventEXT\0"
    "vkResetCommandBuffer\0"
    "vkResetCommandPool\0"
    "vkResetDescriptorPool\0"
    "vkResetEvent\0"
    "vkResetFences\0"
    "vkResetQueryPool\0"
    "vkResetQueryPoolEXT\0"
    "vkSetEvent\0"
    "vkSetPrivateDataEXT\0"
    "vkSignalSemaphore\0"
    "vkTrimCommandPool\0"
    "vkTrimCommandPoolKHR\0"
    "vkUnmapMemory\0"
    "vkUpdateDescriptorSetWithTemplate\0"
    "vkUpdateDescriptorSetWithTemplateKHR\0"
    "vkUpdateDescriptorSets\0"
    "vkWaitForFences\0"
    "vkWaitSemaphores\0"
;

static const struct string_map_entry device_string_map_entries[] = {
    { 0, 0x6bf780dd, 180 }, /* vkAcquireImageANDROID */
    { 22, 0x82860572, 153 }, /* vkAcquireNextImage2KHR */
    { 45, 0xc3fedb2e, 128 }, /* vkAcquireNextImageKHR */
    { 67, 0x8c0c811a, 74 }, /* vkAllocateCommandBuffers */
    { 92, 0x4c449d3a, 63 }, /* vkAllocateDescriptorSets */
    { 117, 0x522b85d3, 6 }, /* vkAllocateMemory */
    { 134, 0xc54f7327, 76 }, /* vkBeginCommandBuffer */
    { 155, 0x6bcbdcb, 14 }, /* vkBindBufferMemory */
    { 174, 0xc27aaf4f, 145 }, /* vkBindBufferMemory2 */
    { 194, 0x6878d3ce, 146 }, /* vkBindBufferMemory2KHR */
    { 217, 0x5caaae4a, 16 }, /* vkBindImageMemory */
    { 235, 0xa9097118, 147 }, /* vkBindImageMemory2 */
    { 254, 0xf18729ad, 148 }, /* vkBindImageMemory2KHR */
    { 276, 0xe561c19f, 115 }, /* vkCmdBeginConditionalRenderingEXT */
    { 310, 0xf5064ea4, 113 }, /* vkCmdBeginQuery */
    { 326, 0x73251a2c, 202 }, /* vkCmdBeginQueryIndexedEXT */
    { 352, 0xcb7a58e3, 121 }, /* vkCmdBeginRenderPass */
    { 373, 0x9c876577, 186 }, /* vkCmdBeginRenderPass2 */
    { 395, 0x8b6b4de6, 187 }, /* vkCmdBeginRenderPass2KHR */
    { 420, 0xb217c94, 200 }, /* vkCmdBeginTransformFeedbackEXT */
    { 451, 0x28c7a5da, 89 }, /* vkCmdBindDescriptorSets */
    { 475, 0x4c22d870, 90 }, /* vkCmdBindIndexBuffer */
    { 496, 0x3af9fd84, 79 }, /* vkCmdBindPipeline */
    { 514, 0x98fdb5cd, 199 }, /* vkCmdBindTransformFeedbackBuffersEXT */
    { 551, 0xa9c83f1d, 91 }, /* vkCmdBindVertexBuffers */
    { 574, 0x331ebf89, 100 }, /* vkCmdBlitImage */
    { 589, 0x93cb5cb8, 107 }, /* vkCmdClearAttachments */
    { 611, 0xb4bc8d08, 105 }, /* vkCmdClearColorImage */
    { 632, 0x4f88e4ba, 106 }, /* vkCmdClearDepthStencilImage */
    { 660, 0xc939a0da, 98 }, /* vkCmdCopyBuffer */
    { 676, 0x929847e, 101 }, /* vkCmdCopyBufferToImage */
    { 699, 0x278effa9, 99 }, /* vkCmdCopyImage */
    { 714, 0x68cddbac, 102 }, /* vkCmdCopyImageToBuffer */
    { 737, 0xdee8c6d4, 119 }, /* vkCmdCopyQueryPoolResults */
    { 763, 0xbd58e867, 96 }, /* vkCmdDispatch */
    { 777, 0xfb767220, 154 }, /* vkCmdDispatchBase */
    { 795, 0x402403e5, 155 }, /* vkCmdDispatchBaseKHR */
    { 816, 0xd6353005, 97 }, /* vkCmdDispatchIndirect */
    { 838, 0x9912c1a1, 92 }, /* vkCmdDraw */
    { 848, 0xbe5a8058, 93 }, /* vkCmdDrawIndexed */
    { 865, 0x94e7ed36, 95 }, /* vkCmdDrawIndexedIndirect */
    { 890, 0xb4acef41, 197 }, /* vkCmdDrawIndexedIndirectCount */
    { 920, 0xda9e8a2c, 198 }, /* vkCmdDrawIndexedIndirectCountKHR */
    { 953, 0xe9ac41bf, 94 }, /* vkCmdDrawIndirect */
    { 971, 0x80c3b089, 204 }, /* vkCmdDrawIndirectByteCountEXT */
    { 1001, 0x40079990, 195 }, /* vkCmdDrawIndirectCount */
    { 1024, 0xf7dd01f5, 196 }, /* vkCmdDrawIndirectCountKHR */
    { 1050, 0x18c8217d, 116 }, /* vkCmdEndConditionalRenderingEXT */
    { 1082, 0xd556fd22, 114 }, /* vkCmdEndQuery */
    { 1096, 0xd5c2f48a, 203 }, /* vkCmdEndQueryIndexedEXT */
    { 1120, 0xdcdb0235, 123 }, /* vkCmdEndRenderPass */
    { 1139, 0x1cbf9115, 190 }, /* vkCmdEndRenderPass2 */
    { 1159, 0x57eebe78, 191 }, /* vkCmdEndRenderPass2KHR */
    { 1182, 0xf008d706, 201 }, /* vkCmdEndTransformFeedbackEXT */
    { 1211, 0x9eaabe40, 124 }, /* vkCmdExecuteCommands */
    { 1232, 0x5bdd2ae0, 104 }, /* vkCmdFillBuffer */
    { 1248, 0x2eeec2f9, 122 }, /* vkCmdNextSubpass */
    { 1265, 0xd4fc131, 188 }, /* vkCmdNextSubpass2 */
    { 1283, 0x25b621bc, 189 }, /* vkCmdNextSubpass2KHR */
    { 1304, 0x97fccfe8, 112 }, /* vkCmdPipelineBarrier */
    { 1325, 0xb1c6b468, 120 }, /* vkCmdPushConstants */
    { 1344, 0xf17232a1, 130 }, /* vkCmdPushDescriptorSetKHR */
    { 1370, 0x3d528981, 162 }, /* vkCmdPushDescriptorSetWithTemplateKHR */
    { 1408, 0x4fccce28, 110 }, /* vkCmdResetEvent */
    { 1424, 0x2f614082, 117 }, /* vkCmdResetQueryPool */
    { 1444, 0x671bb594, 108 }, /* vkCmdResolveImage */
    { 1462, 0x1c989dfb, 84 }, /* vkCmdSetBlendConstants */
    { 1485, 0x30f14d07, 83 }, /* vkCmdSetDepthBias */
    { 1503, 0x7b3a8a63, 85 }, /* vkCmdSetDepthBounds */
    { 1523, 0xaecdae87, 149 }, /* vkCmdSetDeviceMask */
    { 1542, 0xfbb79356, 150 }, /* vkCmdSetDeviceMaskKHR */
    { 1564, 0x64df188b, 163 }, /* vkCmdSetDiscardRectangleEXT */
    { 1592, 0xe257f075, 109 }, /* vkCmdSetEvent */
    { 1606, 0x32282165, 82 }, /* vkCmdSetLineWidth */
    { 1624, 0xa9e2c72, 164 }, /* vkCmdSetSampleLocationsEXT */
    { 1651, 0x48f28c7f, 81 }, /* vkCmdSetScissor */
    { 1667, 0xa8f534e2, 86 }, /* vkCmdSetStencilCompareMask */
    { 1694, 0x83e2b024, 88 }, /* vkCmdSetStencilReference */
    { 1719, 0xe7c4b134, 87 }, /* vkCmdSetStencilWriteMask */
    { 1744, 0x53d6c2b, 80 }, /* vkCmdSetViewport */
    { 1761, 0xd2986b5e, 103 }, /* vkCmdUpdateBuffer */
    { 1779, 0x3b9346b3, 111 }, /* vkCmdWaitEvents */
    { 1795, 0xec4d324c, 118 }, /* vkCmdWriteTimestamp */
    { 1815, 0x7d4282b9, 36 }, /* vkCreateBuffer */
    { 1830, 0x925bd256, 38 }, /* vkCreateBufferView */
    { 1849, 0x820fe476, 71 }, /* vkCreateCommandPool */
    { 1869, 0xf70c85eb, 52 }, /* vkCreateComputePipelines */
    { 1894, 0xfb95a8a4, 60 }, /* vkCreateDescriptorPool */
    { 1917, 0x3c14cc74, 58 }, /* vkCreateDescriptorSetLayout */
    { 1945, 0xad3ce733, 156 }, /* vkCreateDescriptorUpdateTemplate */
    { 1978, 0x5189488a, 157 }, /* vkCreateDescriptorUpdateTemplateKHR */
    { 2014, 0xe7188731, 26 }, /* vkCreateEvent */
    { 2028, 0x958af968, 19 }, /* vkCreateFence */
    { 2042, 0x887a38c4, 66 }, /* vkCreateFramebuffer */
    { 2062, 0x4b59f96d, 51 }, /* vkCreateGraphicsPipelines */
    { 2088, 0x652128c2, 40 }, /* vkCreateImage */
    { 2102, 0xdce077ff, 43 }, /* vkCreateImageView */
    { 2120, 0xcbf6489f, 47 }, /* vkCreatePipelineCache */
    { 2142, 0x451ef1ed, 54 }, /* vkCreatePipelineLayout */
    { 2165, 0xc06d475f, 213 }, /* vkCreatePrivateDataSlotEXT */
    { 2192, 0x5edcd92b, 31 }, /* vkCreateQueryPool */
    { 2210, 0x109a9c18, 68 }, /* vkCreateRenderPass */
    { 2229, 0x46b16d5a, 184 }, /* vkCreateRenderPass2 */
    { 2249, 0xfa16043b, 185 }, /* vkCreateRenderPass2KHR */
    { 2272, 0x13cf03f, 56 }, /* vkCreateSampler */
    { 2288, 0xe6a58c26, 171 }, /* vkCreateSamplerYcbcrConversion */
    { 2319, 0x7482104f, 172 }, /* vkCreateSamplerYcbcrConversionKHR */
    { 2353, 0xf2065e5b, 24 }, /* vkCreateSemaphore */
    { 2371, 0xa0d3cea2, 45 }, /* vkCreateShaderModule */
    { 2392, 0xcdefcaa8, 125 }, /* vkCreateSwapchainKHR */
    { 2413, 0x94a07a45, 37 }, /* vkDestroyBuffer */
    { 2429, 0x98b27962, 39 }, /* vkDestroyBufferView */
    { 2449, 0xd5d83a0a, 72 }, /* vkDestroyCommandPool */
    { 2470, 0x47bdaf30, 61 }, /* vkDestroyDescriptorPool */
    { 2494, 0xa4227b08, 59 }, /* vkDestroyDescriptorSetLayout */
    { 2523, 0xbb2cbe7f, 158 }, /* vkDestroyDescriptorUpdateTemplate */
    { 2557, 0xaa83901e, 159 }, /* vkDestroyDescriptorUpdateTemplateKHR */
    { 2594, 0x1fbcc9cb, 1 }, /* vkDestroyDevice */
    { 2610, 0x4df27c05, 27 }, /* vkDestroyEvent */
    { 2625, 0xfc64ee3c, 20 }, /* vkDestroyFence */
    { 2640, 0xdc428e58, 67 }, /* vkDestroyFramebuffer */
    { 2661, 0xcbfb1d96, 41 }, /* vkDestroyImage */
    { 2676, 0xb5853953, 44 }, /* vkDestroyImageView */
    { 2695, 0x6aac68af, 53 }, /* vkDestroyPipeline */
    { 2713, 0x4112a673, 48 }, /* vkDestroyPipelineCache */
    { 2736, 0x9146f879, 55 }, /* vkDestroyPipelineLayout */
    { 2760, 0xe18d5d6b, 214 }, /* vkDestroyPrivateDataSlotEXT */
    { 2788, 0x37819a7f, 32 }, /* vkDestroyQueryPool */
    { 2807, 0x16f14324, 69 }, /* vkDestroyRenderPass */
    { 2827, 0x3b645153, 57 }, /* vkDestroySampler */
    { 2844, 0x20f261b2, 173 }, /* vkDestroySamplerYcbcrConversion */
    { 2876, 0xaaa623a3, 174 }, /* vkDestroySamplerYcbcrConversionKHR */
    { 2911, 0xcaab1faf, 25 }, /* vkDestroySemaphore */
    { 2930, 0x2d77af6e, 46 }, /* vkDestroyShaderModule */
    { 2952, 0x5a93ab74, 126 }, /* vkDestroySwapchainKHR */
    { 2974, 0xd46c5f24, 5 }, /* vkDeviceWaitIdle */
    { 2991, 0xdbb064, 139 }, /* vkDisplayPowerControlEXT */
    { 3016, 0xaffb5725, 77 }, /* vkEndCommandBuffer */
    { 3035, 0xff52f051, 10 }, /* vkFlushMappedMemoryRanges */
    { 3061, 0xb9db2b91, 75 }, /* vkFreeCommandBuffers */
    { 3082, 0x7a1347b1, 64 }, /* vkFreeDescriptorSets */
    { 3103, 0x8f6f838a, 7 }, /* vkFreeMemory */
    { 3116, 0x7022f0cd, 207 }, /* vkGetBufferDeviceAddress */
    { 3141, 0x3703280c, 208 }, /* vkGetBufferDeviceAddressEXT */
    { 3169, 0xab98422a, 13 }, /* vkGetBufferMemoryRequirements */
    { 3199, 0xd1fd0638, 165 }, /* vkGetBufferMemoryRequirements2 */
    { 3230, 0x78dbe98d, 166 }, /* vkGetBufferMemoryRequirements2KHR */
    { 3264, 0x2a5545a0, 206 }, /* vkGetBufferOpaqueCaptureAddress */
    { 3296, 0xcf3070fe, 182 }, /* vkGetCalibratedTimestampsEXT */
    { 3325, 0xfeac9573, 176 }, /* vkGetDescriptorSetLayoutSupport */
    { 3357, 0xd7e44a, 177 }, /* vkGetDescriptorSetLayoutSupportKHR */
    { 3392, 0x2e218c10, 143 }, /* vkGetDeviceGroupPeerMemoryFeatures */
    { 3427, 0xa3809375, 144 }, /* vkGetDeviceGroupPeerMemoryFeaturesKHR */
    { 3465, 0xf72c87d4, 151 }, /* vkGetDeviceGroupPresentCapabilitiesKHR */
    { 3504, 0x6b9448c3, 152 }, /* vkGetDeviceGroupSurfacePresentModesKHR */
    { 3543, 0x46e38db5, 12 }, /* vkGetDeviceMemoryCommitment */
    { 3571, 0x9a0fe777, 209 }, /* vkGetDeviceMemoryOpaqueCaptureAddress */
    { 3609, 0xba013486, 0 }, /* vkGetDeviceProcAddr */
    { 3629, 0xcc920d9a, 2 }, /* vkGetDeviceQueue */
    { 3646, 0xb11a6348, 175 }, /* vkGetDeviceQueue2 */
    { 3664, 0x96d834b, 28 }, /* vkGetEventStatus */
    { 3681, 0x69a5d6af, 137 }, /* vkGetFenceFdKHR */
    { 3697, 0x5f391892, 22 }, /* vkGetFenceStatus */
    { 3714, 0x916f1e63, 15 }, /* vkGetImageMemoryRequirements */
    { 3743, 0x56e213f7, 167 }, /* vkGetImageMemoryRequirements2 */
    { 3773, 0x8de28366, 168 }, /* vkGetImageMemoryRequirements2KHR */
    { 3806, 0x15855f5b, 17 }, /* vkGetImageSparseMemoryRequirements */
    { 3841, 0xbd4e3d3f, 169 }, /* vkGetImageSparseMemoryRequirements2 */
    { 3877, 0x3df40f5e, 170 }, /* vkGetImageSparseMemoryRequirements2KHR */
    { 3916, 0x9163b686, 42 }, /* vkGetImageSubresourceLayout */
    { 3944, 0x503c14c5, 133 }, /* vkGetMemoryFdKHR */
    { 3961, 0xb028a792, 134 }, /* vkGetMemoryFdPropertiesKHR */
    { 3988, 0x7030ee5b, 183 }, /* vkGetMemoryHostPointerPropertiesEXT */
    { 4024, 0x2092a349, 49 }, /* vkGetPipelineCacheData */
    { 4047, 0x8b20fc09, 212 }, /* vkGetPipelineExecutableInternalRepresentationsKHR */
    { 4097, 0x748dd8cd, 210 }, /* vkGetPipelineExecutablePropertiesKHR */
    { 4134, 0x5c4d6435, 211 }, /* vkGetPipelineExecutableStatisticsKHR */
    { 4171, 0x2dc1491d, 216 }, /* vkGetPrivateDataEXT */
    { 4191, 0xbf3f2cb3, 33 }, /* vkGetQueryPoolResults */
    { 4213, 0x3b54d93a, 205 }, /* vkGetRayTracingShaderGroupHandlesNV */
    { 4249, 0xa9820d22, 70 }, /* vkGetRenderAreaGranularity */
    { 4276, 0xd05a61a0, 192 }, /* vkGetSemaphoreCounterValue */
    { 4303, 0x3e0e9884, 135 }, /* vkGetSemaphoreFdKHR */
    { 4323, 0xa4aeb5a, 142 }, /* vkGetSwapchainCounterEXT */
    { 4348, 0x219d929, 179 }, /* vkGetSwapchainGrallocUsage2ANDROID */
    { 4383, 0x4979c9a3, 178 }, /* vkGetSwapchainGrallocUsageANDROID */
    { 4417, 0x57695f28, 127 }, /* vkGetSwapchainImagesKHR */
    { 4441, 0x51df0390, 138 }, /* vkImportFenceFdKHR */
    { 4460, 0x36337c05, 136 }, /* vkImportSemaphoreFdKHR */
    { 4483, 0x1e115cca, 11 }, /* vkInvalidateMappedMemoryRanges */
    { 4514, 0xcb977bd8, 8 }, /* vkMapMemory */
    { 4526, 0xc3499606, 50 }, /* vkMergePipelineCaches */
    { 4548, 0xc3628a09, 18 }, /* vkQueueBindSparse */
    { 4566, 0xfc5fb6ce, 129 }, /* vkQueuePresentKHR */
    { 4584, 0xa0313eef, 181 }, /* vkQueueSignalReleaseImageANDROID */
    { 4617, 0xfa4713ec, 3 }, /* vkQueueSubmit */
    { 4631, 0x6f8fc2a5, 4 }, /* vkQueueWaitIdle */
    { 4647, 0x26cc78f5, 140 }, /* vkRegisterDeviceEventEXT */
    { 4672, 0x4a0bd849, 141 }, /* vkRegisterDisplayEventEXT */
    { 4698, 0x847dc731, 78 }, /* vkResetCommandBuffer */
    { 4719, 0x6da9f7fd, 73 }, /* vkResetCommandPool */
    { 4738, 0x9bd85f5, 62 }, /* vkResetDescriptorPool */
    { 4760, 0x6d373ba8, 30 }, /* vkResetEvent */
    { 4773, 0x684781dc, 21 }, /* vkResetFences */
    { 4787, 0x4e671e02, 34 }, /* vkResetQueryPool */
    { 4804, 0xe6701e5f, 35 }, /* vkResetQueryPoolEXT */
    { 4824, 0x592ae5f5, 29 }, /* vkSetEvent */
    { 4835, 0x23456729, 215 }, /* vkSetPrivateDataEXT */
    { 4855, 0xcd347297, 194 }, /* vkSignalSemaphore */
    { 4873, 0xfef2fb38, 131 }, /* vkTrimCommandPool */
    { 4891, 0x51177c8d, 132 }, /* vkTrimCommandPoolKHR */
    { 4912, 0x1a1a0e2f, 9 }, /* vkUnmapMemory */
    { 4926, 0x5349c9d, 160 }, /* vkUpdateDescriptorSetWithTemplate */
    { 4960, 0x214ad230, 161 }, /* vkUpdateDescriptorSetWithTemplateKHR */
    { 4997, 0xbfd090ae, 65 }, /* vkUpdateDescriptorSets */
    { 5020, 0x19d64c81, 23 }, /* vkWaitForFences */
    { 5036, 0x74368ad9, 193 }, /* vkWaitSemaphores */
};

/* Hash table stats:
 * size 217 entries
 * collisions entries:
 *     0      177
 *     1      26
 *     2      8
 *     3      5
 *     4      0
 *     5      0
 *     6      1
 *     7      0
 *     8      0
 *     9+     0
 */

#define none 0xffff
static const uint16_t device_string_map[512] = {
    none,
    none,
    0x00cc,
    none,
    none,
    0x0025,
    0x00bf,
    none,
    0x00c9,
    0x00ae,
    0x0070,
    none,
    0x008f,
    none,
    none,
    none,
    0x0097,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x0065,
    none,
    none,
    0x00ce,
    0x00c0,
    none,
    0x0074,
    none,
    0x0023,
    none,
    none,
    none,
    0x004d,
    none,
    0x0069,
    none,
    0x003f,
    none,
    0x0090,
    0x004f,
    0x000f,
    none,
    none,
    0x00d3,
    0x00d5,
    none,
    none,
    none,
    none,
    0x0032,
    none,
    none,
    0x0091,
    none,
    none,
    0x0067,
    0x0077,
    none,
    0x0076,
    0x002a,
    0x0036,
    none,
    none,
    none,
    none,
    0x006e,
    none,
    none,
    0x00b0,
    0x00c6,
    0x000a,
    none,
    0x0052,
    none,
    none,
    0x006a,
    none,
    0x008a,
    0x0068,
    none,
    none,
    none,
    0x0054,
    none,
    0x0027,
    none,
    none,
    0x006b,
    none,
    0x0096,
    none,
    0x00cd,
    none,
    none,
    none,
    0x0044,
    0x0088,
    none,
    none,
    0x0022,
    0x003c,
    none,
    none,
    0x0078,
    none,
    none,
    0x00ac,
    none,
    0x0015,
    none,
    0x004a,
    0x007c,
    0x0058,
    0x0048,
    0x0055,
    0x00bc,
    0x0034,
    0x007d,
    none,
    none,
    none,
    none,
    0x001e,
    0x004b,
    none,
    0x00d7,
    0x0040,
    none,
    0x00b6,
    none,
    0x009d,
    0x0045,
    none,
    0x002c,
    0x0031,
    0x0047,
    none,
    0x00d2,
    none,
    none,
    none,
    none,
    0x0073,
    none,
    0x0013,
    none,
    none,
    0x00d0,
    none,
    0x00a9,
    none,
    none,
    0x00a3,
    0x005a,
    none,
    0x0061,
    none,
    0x003d,
    0x006c,
    none,
    0x000e,
    0x007f,
    none,
    none,
    0x006d,
    none,
    none,
    none,
    none,
    none,
    0x00d6,
    0x007b,
    0x00d4,
    none,
    none,
    0x0051,
    none,
    none,
    none,
    0x0057,
    0x001a,
    0x0053,
    0x001c,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x005f,
    0x009a,
    0x005d,
    0x00aa,
    0x00b2,
    none,
    none,
    none,
    0x00bd,
    0x00a2,
    none,
    0x008e,
    0x00c1,
    none,
    none,
    none,
    none,
    none,
    0x0021,
    0x00a1,
    none,
    none,
    none,
    0x00d8,
    0x001d,
    none,
    none,
    0x0000,
    0x00c4,
    none,
    0x0037,
    none,
    0x004c,
    0x0010,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x00c2,
    none,
    none,
    none,
    0x00af,
    none,
    0x00c5,
    none,
    none,
    none,
    0x0038,
    none,
    none,
    none,
    none,
    0x0094,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x0035,
    0x0043,
    0x001b,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x0033,
    none,
    none,
    0x000b,
    none,
    0x0003,
    0x0072,
    none,
    0x0018,
    none,
    none,
    none,
    none,
    0x0030,
    none,
    0x0080,
    0x0089,
    none,
    0x0006,
    0x00ba,
    0x00b8,
    none,
    0x0064,
    none,
    none,
    0x0002,
    none,
    0x0071,
    0x0039,
    none,
    0x0059,
    0x004e,
    0x00b4,
    0x0028,
    0x0087,
    0x00d1,
    none,
    0x0004,
    none,
    0x00cf,
    none,
    none,
    0x00a7,
    none,
    0x0029,
    none,
    0x00b1,
    0x005b,
    none,
    none,
    none,
    0x009f,
    0x00ad,
    none,
    0x00a0,
    none,
    0x00b3,
    none,
    0x0008,
    none,
    none,
    none,
    0x007a,
    none,
    none,
    0x0046,
    0x00c7,
    none,
    none,
    0x0066,
    0x00a6,
    none,
    none,
    0x0050,
    0x0063,
    none,
    none,
    0x006f,
    none,
    none,
    0x0049,
    0x0081,
    none,
    0x005c,
    none,
    none,
    0x007e,
    none,
    0x005e,
    0x0085,
    none,
    none,
    0x00a8,
    0x0001,
    0x0095,
    0x0086,
    0x0098,
    none,
    0x0011,
    none,
    0x00a5,
    none,
    none,
    none,
    0x002f,
    none,
    none,
    0x00b7,
    0x003e,
    none,
    none,
    0x0016,
    none,
    none,
    none,
    none,
    0x0019,
    0x008d,
    none,
    none,
    0x0092,
    none,
    none,
    0x002d,
    0x008b,
    0x00ab,
    none,
    0x0041,
    none,
    0x0079,
    none,
    none,
    none,
    0x009e,
    none,
    none,
    0x009c,
    none,
    0x000d,
    0x0093,
    0x0026,
    none,
    0x0083,
    none,
    none,
    none,
    none,
    0x00ca,
    0x001f,
    none,
    none,
    0x0020,
    0x000c,
    none,
    0x0084,
    none,
    0x008c,
    0x0082,
    0x00b5,
    none,
    0x009b,
    0x00b9,
    none,
    none,
    none,
    none,
    none,
    0x003a,
    none,
    none,
    0x002b,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x00bb,
    none,
    0x0007,
    none,
    0x0017,
    0x0009,
    none,
    none,
    none,
    none,
    0x0005,
    0x0099,
    none,
    none,
    none,
    0x00be,
    none,
    0x0014,
    none,
    0x00cb,
    none,
    0x0075,
    none,
    none,
    none,
    none,
    none,
    none,
    0x0024,
    0x0012,
    none,
    0x003b,
    none,
    none,
    0x0056,
    0x00c3,
    0x0062,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x002e,
    none,
    0x00a4,
    none,
    none,
    none,
    0x0042,
    none,
    0x00c8,
    none,
    0x0060,
};

static int
device_string_map_lookup(const char *str)
{
    static const uint32_t prime_factor = 5024183;
    static const uint32_t prime_step = 19;
    const struct string_map_entry *e;
    uint32_t hash, h;
    uint16_t i;
    const char *p;

    hash = 0;
    for (p = str; *p; p++)
        hash = hash * prime_factor + *p;

    h = hash;
    while (1) {
        i = device_string_map[h & 511];
        if (i == none)
           return -1;
        e = &device_string_map_entries[i];
        if (e->hash == hash && strcmp(str, device_strings + e->name) == 0)
            return e->num;
        h += prime_step;
    }

    return -1;
}

static const char *
device_entry_name(int num)
{
   for (int i = 0; i < ARRAY_SIZE(device_string_map_entries); i++) {
      if (device_string_map_entries[i].num == num)
         return &device_strings[device_string_map_entries[i].name];
   }
   return NULL;
}


/* Weak aliases for all potential implementations. These will resolve to
 * NULL if they're not defined, which lets the resolve_entrypoint() function
 * either pick the correct entry point.
 */

  VkResult lvp_CreateInstance(const VkInstanceCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkInstance* pInstance) __attribute__ ((weak));
  void lvp_DestroyInstance(VkInstance instance, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
  VkResult lvp_EnumeratePhysicalDevices(VkInstance instance, uint32_t* pPhysicalDeviceCount, VkPhysicalDevice* pPhysicalDevices) __attribute__ ((weak));
  PFN_vkVoidFunction lvp_GetInstanceProcAddr(VkInstance instance, const char* pName) __attribute__ ((weak));
  VkResult lvp_EnumerateInstanceVersion(uint32_t* pApiVersion) __attribute__ ((weak));
  VkResult lvp_EnumerateInstanceLayerProperties(uint32_t* pPropertyCount, VkLayerProperties* pProperties) __attribute__ ((weak));
  VkResult lvp_EnumerateInstanceExtensionProperties(const char* pLayerName, uint32_t* pPropertyCount, VkExtensionProperties* pProperties) __attribute__ ((weak));
  VkResult lvp_CreateDisplayPlaneSurfaceKHR(VkInstance instance, const VkDisplaySurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
  void lvp_DestroySurfaceKHR(VkInstance instance, VkSurfaceKHR surface, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
  VkResult lvp_CreateWaylandSurfaceKHR(VkInstance instance, const VkWaylandSurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
  VkResult lvp_CreateXlibSurfaceKHR(VkInstance instance, const VkXlibSurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
  VkResult lvp_CreateXcbSurfaceKHR(VkInstance instance, const VkXcbSurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XCB_KHR
  VkResult lvp_CreateDebugReportCallbackEXT(VkInstance instance, const VkDebugReportCallbackCreateInfoEXT* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDebugReportCallbackEXT* pCallback) __attribute__ ((weak));
  void lvp_DestroyDebugReportCallbackEXT(VkInstance instance, VkDebugReportCallbackEXT callback, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
  void lvp_DebugReportMessageEXT(VkInstance instance, VkDebugReportFlagsEXT flags, VkDebugReportObjectTypeEXT objectType, uint64_t object, size_t location, int32_t messageCode, const char* pLayerPrefix, const char* pMessage) __attribute__ ((weak));
  VkResult lvp_EnumeratePhysicalDeviceGroups(VkInstance instance, uint32_t* pPhysicalDeviceGroupCount, VkPhysicalDeviceGroupProperties* pPhysicalDeviceGroupProperties) __attribute__ ((weak));
    
const struct lvp_instance_dispatch_table lvp_instance_dispatch_table = {
  .vkCreateInstance = lvp_CreateInstance,
  .vkDestroyInstance = lvp_DestroyInstance,
  .vkEnumeratePhysicalDevices = lvp_EnumeratePhysicalDevices,
  .vkGetInstanceProcAddr = lvp_GetInstanceProcAddr,
  .vkEnumerateInstanceVersion = lvp_EnumerateInstanceVersion,
  .vkEnumerateInstanceLayerProperties = lvp_EnumerateInstanceLayerProperties,
  .vkEnumerateInstanceExtensionProperties = lvp_EnumerateInstanceExtensionProperties,
  .vkCreateDisplayPlaneSurfaceKHR = lvp_CreateDisplayPlaneSurfaceKHR,
  .vkDestroySurfaceKHR = lvp_DestroySurfaceKHR,
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
  .vkCreateWaylandSurfaceKHR = lvp_CreateWaylandSurfaceKHR,
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
  .vkCreateXlibSurfaceKHR = lvp_CreateXlibSurfaceKHR,
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
  .vkCreateXcbSurfaceKHR = lvp_CreateXcbSurfaceKHR,
#endif // VK_USE_PLATFORM_XCB_KHR
  .vkCreateDebugReportCallbackEXT = lvp_CreateDebugReportCallbackEXT,
  .vkDestroyDebugReportCallbackEXT = lvp_DestroyDebugReportCallbackEXT,
  .vkDebugReportMessageEXT = lvp_DebugReportMessageEXT,
  .vkEnumeratePhysicalDeviceGroups = lvp_EnumeratePhysicalDeviceGroups,
  .vkEnumeratePhysicalDeviceGroupsKHR = lvp_EnumeratePhysicalDeviceGroups,
};

  void lvp_GetPhysicalDeviceProperties(VkPhysicalDevice physicalDevice, VkPhysicalDeviceProperties* pProperties) __attribute__ ((weak));
  void lvp_GetPhysicalDeviceQueueFamilyProperties(VkPhysicalDevice physicalDevice, uint32_t* pQueueFamilyPropertyCount, VkQueueFamilyProperties* pQueueFamilyProperties) __attribute__ ((weak));
  void lvp_GetPhysicalDeviceMemoryProperties(VkPhysicalDevice physicalDevice, VkPhysicalDeviceMemoryProperties* pMemoryProperties) __attribute__ ((weak));
  void lvp_GetPhysicalDeviceFeatures(VkPhysicalDevice physicalDevice, VkPhysicalDeviceFeatures* pFeatures) __attribute__ ((weak));
  void lvp_GetPhysicalDeviceFormatProperties(VkPhysicalDevice physicalDevice, VkFormat format, VkFormatProperties* pFormatProperties) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceImageFormatProperties(VkPhysicalDevice physicalDevice, VkFormat format, VkImageType type, VkImageTiling tiling, VkImageUsageFlags usage, VkImageCreateFlags flags, VkImageFormatProperties* pImageFormatProperties) __attribute__ ((weak));
  VkResult lvp_CreateDevice(VkPhysicalDevice physicalDevice, const VkDeviceCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDevice* pDevice) __attribute__ ((weak));
  VkResult lvp_EnumerateDeviceLayerProperties(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkLayerProperties* pProperties) __attribute__ ((weak));
  VkResult lvp_EnumerateDeviceExtensionProperties(VkPhysicalDevice physicalDevice, const char* pLayerName, uint32_t* pPropertyCount, VkExtensionProperties* pProperties) __attribute__ ((weak));
  void lvp_GetPhysicalDeviceSparseImageFormatProperties(VkPhysicalDevice physicalDevice, VkFormat format, VkImageType type, VkSampleCountFlagBits samples, VkImageUsageFlags usage, VkImageTiling tiling, uint32_t* pPropertyCount, VkSparseImageFormatProperties* pProperties) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceDisplayPropertiesKHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayPropertiesKHR* pProperties) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceDisplayPlanePropertiesKHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayPlanePropertiesKHR* pProperties) __attribute__ ((weak));
  VkResult lvp_GetDisplayPlaneSupportedDisplaysKHR(VkPhysicalDevice physicalDevice, uint32_t planeIndex, uint32_t* pDisplayCount, VkDisplayKHR* pDisplays) __attribute__ ((weak));
  VkResult lvp_GetDisplayModePropertiesKHR(VkPhysicalDevice physicalDevice, VkDisplayKHR display, uint32_t* pPropertyCount, VkDisplayModePropertiesKHR* pProperties) __attribute__ ((weak));
  VkResult lvp_CreateDisplayModeKHR(VkPhysicalDevice physicalDevice, VkDisplayKHR display, const VkDisplayModeCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDisplayModeKHR* pMode) __attribute__ ((weak));
  VkResult lvp_GetDisplayPlaneCapabilitiesKHR(VkPhysicalDevice physicalDevice, VkDisplayModeKHR mode, uint32_t planeIndex, VkDisplayPlaneCapabilitiesKHR* pCapabilities) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceSurfaceSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, VkSurfaceKHR surface, VkBool32* pSupported) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceSurfaceCapabilitiesKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, VkSurfaceCapabilitiesKHR* pSurfaceCapabilities) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceSurfaceFormatsKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, uint32_t* pSurfaceFormatCount, VkSurfaceFormatKHR* pSurfaceFormats) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceSurfacePresentModesKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, uint32_t* pPresentModeCount, VkPresentModeKHR* pPresentModes) __attribute__ ((weak));
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
  VkBool32 lvp_GetPhysicalDeviceWaylandPresentationSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, struct wl_display* display) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
  VkBool32 lvp_GetPhysicalDeviceXlibPresentationSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, Display* dpy, VisualID visualID) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
  VkBool32 lvp_GetPhysicalDeviceXcbPresentationSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, xcb_connection_t* connection, xcb_visualid_t visual_id) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XCB_KHR
  void lvp_GetPhysicalDeviceFeatures2(VkPhysicalDevice physicalDevice, VkPhysicalDeviceFeatures2* pFeatures) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceProperties2(VkPhysicalDevice physicalDevice, VkPhysicalDeviceProperties2* pProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceFormatProperties2(VkPhysicalDevice physicalDevice, VkFormat format, VkFormatProperties2* pFormatProperties) __attribute__ ((weak));
      VkResult lvp_GetPhysicalDeviceImageFormatProperties2(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceImageFormatInfo2* pImageFormatInfo, VkImageFormatProperties2* pImageFormatProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceQueueFamilyProperties2(VkPhysicalDevice physicalDevice, uint32_t* pQueueFamilyPropertyCount, VkQueueFamilyProperties2* pQueueFamilyProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceMemoryProperties2(VkPhysicalDevice physicalDevice, VkPhysicalDeviceMemoryProperties2* pMemoryProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceSparseImageFormatProperties2(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceSparseImageFormatInfo2* pFormatInfo, uint32_t* pPropertyCount, VkSparseImageFormatProperties2* pProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceExternalBufferProperties(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceExternalBufferInfo* pExternalBufferInfo, VkExternalBufferProperties* pExternalBufferProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceExternalSemaphoreProperties(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceExternalSemaphoreInfo* pExternalSemaphoreInfo, VkExternalSemaphoreProperties* pExternalSemaphoreProperties) __attribute__ ((weak));
      void lvp_GetPhysicalDeviceExternalFenceProperties(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceExternalFenceInfo* pExternalFenceInfo, VkExternalFenceProperties* pExternalFenceProperties) __attribute__ ((weak));
      VkResult lvp_ReleaseDisplayEXT(VkPhysicalDevice physicalDevice, VkDisplayKHR display) __attribute__ ((weak));
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
  VkResult lvp_AcquireXlibDisplayEXT(VkPhysicalDevice physicalDevice, Display* dpy, VkDisplayKHR display) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
  VkResult lvp_GetRandROutputDisplayEXT(VkPhysicalDevice physicalDevice, Display* dpy, RROutput rrOutput, VkDisplayKHR* pDisplay) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
  VkResult lvp_GetPhysicalDeviceSurfaceCapabilities2EXT(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, VkSurfaceCapabilities2EXT* pSurfaceCapabilities) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDevicePresentRectanglesKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, uint32_t* pRectCount, VkRect2D* pRects) __attribute__ ((weak));
  void lvp_GetPhysicalDeviceMultisamplePropertiesEXT(VkPhysicalDevice physicalDevice, VkSampleCountFlagBits samples, VkMultisamplePropertiesEXT* pMultisampleProperties) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceSurfaceCapabilities2KHR(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceSurfaceInfo2KHR* pSurfaceInfo, VkSurfaceCapabilities2KHR* pSurfaceCapabilities) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceSurfaceFormats2KHR(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceSurfaceInfo2KHR* pSurfaceInfo, uint32_t* pSurfaceFormatCount, VkSurfaceFormat2KHR* pSurfaceFormats) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceDisplayProperties2KHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayProperties2KHR* pProperties) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceDisplayPlaneProperties2KHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayPlaneProperties2KHR* pProperties) __attribute__ ((weak));
  VkResult lvp_GetDisplayModeProperties2KHR(VkPhysicalDevice physicalDevice, VkDisplayKHR display, uint32_t* pPropertyCount, VkDisplayModeProperties2KHR* pProperties) __attribute__ ((weak));
  VkResult lvp_GetDisplayPlaneCapabilities2KHR(VkPhysicalDevice physicalDevice, const VkDisplayPlaneInfo2KHR* pDisplayPlaneInfo, VkDisplayPlaneCapabilities2KHR* pCapabilities) __attribute__ ((weak));
  VkResult lvp_GetPhysicalDeviceCalibrateableTimeDomainsEXT(VkPhysicalDevice physicalDevice, uint32_t* pTimeDomainCount, VkTimeDomainEXT* pTimeDomains) __attribute__ ((weak));

const struct lvp_physical_device_dispatch_table lvp_physical_device_dispatch_table = {
  .vkGetPhysicalDeviceProperties = lvp_GetPhysicalDeviceProperties,
  .vkGetPhysicalDeviceQueueFamilyProperties = lvp_GetPhysicalDeviceQueueFamilyProperties,
  .vkGetPhysicalDeviceMemoryProperties = lvp_GetPhysicalDeviceMemoryProperties,
  .vkGetPhysicalDeviceFeatures = lvp_GetPhysicalDeviceFeatures,
  .vkGetPhysicalDeviceFormatProperties = lvp_GetPhysicalDeviceFormatProperties,
  .vkGetPhysicalDeviceImageFormatProperties = lvp_GetPhysicalDeviceImageFormatProperties,
  .vkCreateDevice = lvp_CreateDevice,
  .vkEnumerateDeviceLayerProperties = lvp_EnumerateDeviceLayerProperties,
  .vkEnumerateDeviceExtensionProperties = lvp_EnumerateDeviceExtensionProperties,
  .vkGetPhysicalDeviceSparseImageFormatProperties = lvp_GetPhysicalDeviceSparseImageFormatProperties,
  .vkGetPhysicalDeviceDisplayPropertiesKHR = lvp_GetPhysicalDeviceDisplayPropertiesKHR,
  .vkGetPhysicalDeviceDisplayPlanePropertiesKHR = lvp_GetPhysicalDeviceDisplayPlanePropertiesKHR,
  .vkGetDisplayPlaneSupportedDisplaysKHR = lvp_GetDisplayPlaneSupportedDisplaysKHR,
  .vkGetDisplayModePropertiesKHR = lvp_GetDisplayModePropertiesKHR,
  .vkCreateDisplayModeKHR = lvp_CreateDisplayModeKHR,
  .vkGetDisplayPlaneCapabilitiesKHR = lvp_GetDisplayPlaneCapabilitiesKHR,
  .vkGetPhysicalDeviceSurfaceSupportKHR = lvp_GetPhysicalDeviceSurfaceSupportKHR,
  .vkGetPhysicalDeviceSurfaceCapabilitiesKHR = lvp_GetPhysicalDeviceSurfaceCapabilitiesKHR,
  .vkGetPhysicalDeviceSurfaceFormatsKHR = lvp_GetPhysicalDeviceSurfaceFormatsKHR,
  .vkGetPhysicalDeviceSurfacePresentModesKHR = lvp_GetPhysicalDeviceSurfacePresentModesKHR,
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
  .vkGetPhysicalDeviceWaylandPresentationSupportKHR = lvp_GetPhysicalDeviceWaylandPresentationSupportKHR,
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
  .vkGetPhysicalDeviceXlibPresentationSupportKHR = lvp_GetPhysicalDeviceXlibPresentationSupportKHR,
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
  .vkGetPhysicalDeviceXcbPresentationSupportKHR = lvp_GetPhysicalDeviceXcbPresentationSupportKHR,
#endif // VK_USE_PLATFORM_XCB_KHR
  .vkGetPhysicalDeviceFeatures2 = lvp_GetPhysicalDeviceFeatures2,
  .vkGetPhysicalDeviceFeatures2KHR = lvp_GetPhysicalDeviceFeatures2,
  .vkGetPhysicalDeviceProperties2 = lvp_GetPhysicalDeviceProperties2,
  .vkGetPhysicalDeviceProperties2KHR = lvp_GetPhysicalDeviceProperties2,
  .vkGetPhysicalDeviceFormatProperties2 = lvp_GetPhysicalDeviceFormatProperties2,
  .vkGetPhysicalDeviceFormatProperties2KHR = lvp_GetPhysicalDeviceFormatProperties2,
  .vkGetPhysicalDeviceImageFormatProperties2 = lvp_GetPhysicalDeviceImageFormatProperties2,
  .vkGetPhysicalDeviceImageFormatProperties2KHR = lvp_GetPhysicalDeviceImageFormatProperties2,
  .vkGetPhysicalDeviceQueueFamilyProperties2 = lvp_GetPhysicalDeviceQueueFamilyProperties2,
  .vkGetPhysicalDeviceQueueFamilyProperties2KHR = lvp_GetPhysicalDeviceQueueFamilyProperties2,
  .vkGetPhysicalDeviceMemoryProperties2 = lvp_GetPhysicalDeviceMemoryProperties2,
  .vkGetPhysicalDeviceMemoryProperties2KHR = lvp_GetPhysicalDeviceMemoryProperties2,
  .vkGetPhysicalDeviceSparseImageFormatProperties2 = lvp_GetPhysicalDeviceSparseImageFormatProperties2,
  .vkGetPhysicalDeviceSparseImageFormatProperties2KHR = lvp_GetPhysicalDeviceSparseImageFormatProperties2,
  .vkGetPhysicalDeviceExternalBufferProperties = lvp_GetPhysicalDeviceExternalBufferProperties,
  .vkGetPhysicalDeviceExternalBufferPropertiesKHR = lvp_GetPhysicalDeviceExternalBufferProperties,
  .vkGetPhysicalDeviceExternalSemaphoreProperties = lvp_GetPhysicalDeviceExternalSemaphoreProperties,
  .vkGetPhysicalDeviceExternalSemaphorePropertiesKHR = lvp_GetPhysicalDeviceExternalSemaphoreProperties,
  .vkGetPhysicalDeviceExternalFenceProperties = lvp_GetPhysicalDeviceExternalFenceProperties,
  .vkGetPhysicalDeviceExternalFencePropertiesKHR = lvp_GetPhysicalDeviceExternalFenceProperties,
  .vkReleaseDisplayEXT = lvp_ReleaseDisplayEXT,
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
  .vkAcquireXlibDisplayEXT = lvp_AcquireXlibDisplayEXT,
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
  .vkGetRandROutputDisplayEXT = lvp_GetRandROutputDisplayEXT,
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
  .vkGetPhysicalDeviceSurfaceCapabilities2EXT = lvp_GetPhysicalDeviceSurfaceCapabilities2EXT,
  .vkGetPhysicalDevicePresentRectanglesKHR = lvp_GetPhysicalDevicePresentRectanglesKHR,
  .vkGetPhysicalDeviceMultisamplePropertiesEXT = lvp_GetPhysicalDeviceMultisamplePropertiesEXT,
  .vkGetPhysicalDeviceSurfaceCapabilities2KHR = lvp_GetPhysicalDeviceSurfaceCapabilities2KHR,
  .vkGetPhysicalDeviceSurfaceFormats2KHR = lvp_GetPhysicalDeviceSurfaceFormats2KHR,
  .vkGetPhysicalDeviceDisplayProperties2KHR = lvp_GetPhysicalDeviceDisplayProperties2KHR,
  .vkGetPhysicalDeviceDisplayPlaneProperties2KHR = lvp_GetPhysicalDeviceDisplayPlaneProperties2KHR,
  .vkGetDisplayModeProperties2KHR = lvp_GetDisplayModeProperties2KHR,
  .vkGetDisplayPlaneCapabilities2KHR = lvp_GetDisplayPlaneCapabilities2KHR,
  .vkGetPhysicalDeviceCalibrateableTimeDomainsEXT = lvp_GetPhysicalDeviceCalibrateableTimeDomainsEXT,
};


      PFN_vkVoidFunction __attribute__ ((weak))
      lvp_GetDeviceProcAddr(VkDevice device, const char* pName)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceProcAddr(device, pName);
      }
      void __attribute__ ((weak))
      lvp_DestroyDevice(VkDevice device, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyDevice(device, pAllocator);
      }
      void __attribute__ ((weak))
      lvp_GetDeviceQueue(VkDevice device, uint32_t queueFamilyIndex, uint32_t queueIndex, VkQueue* pQueue)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceQueue(device, queueFamilyIndex, queueIndex, pQueue);
      }
      VkResult __attribute__ ((weak))
      lvp_QueueSubmit(VkQueue queue, uint32_t submitCount, const VkSubmitInfo* pSubmits, VkFence fence)
      {
          LVP_FROM_HANDLE(lvp_queue, lvp_queue, queue);
          return lvp_queue->device->dispatch.vkQueueSubmit(queue, submitCount, pSubmits, fence);
      }
      VkResult __attribute__ ((weak))
      lvp_QueueWaitIdle(VkQueue queue)
      {
          LVP_FROM_HANDLE(lvp_queue, lvp_queue, queue);
          return lvp_queue->device->dispatch.vkQueueWaitIdle(queue);
      }
      VkResult __attribute__ ((weak))
      lvp_DeviceWaitIdle(VkDevice device)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDeviceWaitIdle(device);
      }
      VkResult __attribute__ ((weak))
      lvp_AllocateMemory(VkDevice device, const VkMemoryAllocateInfo* pAllocateInfo, const VkAllocationCallbacks* pAllocator, VkDeviceMemory* pMemory)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkAllocateMemory(device, pAllocateInfo, pAllocator, pMemory);
      }
      void __attribute__ ((weak))
      lvp_FreeMemory(VkDevice device, VkDeviceMemory memory, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkFreeMemory(device, memory, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_MapMemory(VkDevice device, VkDeviceMemory memory, VkDeviceSize offset, VkDeviceSize size, VkMemoryMapFlags flags, void** ppData)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkMapMemory(device, memory, offset, size, flags, ppData);
      }
      void __attribute__ ((weak))
      lvp_UnmapMemory(VkDevice device, VkDeviceMemory memory)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkUnmapMemory(device, memory);
      }
      VkResult __attribute__ ((weak))
      lvp_FlushMappedMemoryRanges(VkDevice device, uint32_t memoryRangeCount, const VkMappedMemoryRange* pMemoryRanges)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkFlushMappedMemoryRanges(device, memoryRangeCount, pMemoryRanges);
      }
      VkResult __attribute__ ((weak))
      lvp_InvalidateMappedMemoryRanges(VkDevice device, uint32_t memoryRangeCount, const VkMappedMemoryRange* pMemoryRanges)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkInvalidateMappedMemoryRanges(device, memoryRangeCount, pMemoryRanges);
      }
      void __attribute__ ((weak))
      lvp_GetDeviceMemoryCommitment(VkDevice device, VkDeviceMemory memory, VkDeviceSize* pCommittedMemoryInBytes)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceMemoryCommitment(device, memory, pCommittedMemoryInBytes);
      }
      void __attribute__ ((weak))
      lvp_GetBufferMemoryRequirements(VkDevice device, VkBuffer buffer, VkMemoryRequirements* pMemoryRequirements)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetBufferMemoryRequirements(device, buffer, pMemoryRequirements);
      }
      VkResult __attribute__ ((weak))
      lvp_BindBufferMemory(VkDevice device, VkBuffer buffer, VkDeviceMemory memory, VkDeviceSize memoryOffset)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkBindBufferMemory(device, buffer, memory, memoryOffset);
      }
      void __attribute__ ((weak))
      lvp_GetImageMemoryRequirements(VkDevice device, VkImage image, VkMemoryRequirements* pMemoryRequirements)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetImageMemoryRequirements(device, image, pMemoryRequirements);
      }
      VkResult __attribute__ ((weak))
      lvp_BindImageMemory(VkDevice device, VkImage image, VkDeviceMemory memory, VkDeviceSize memoryOffset)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkBindImageMemory(device, image, memory, memoryOffset);
      }
      void __attribute__ ((weak))
      lvp_GetImageSparseMemoryRequirements(VkDevice device, VkImage image, uint32_t* pSparseMemoryRequirementCount, VkSparseImageMemoryRequirements* pSparseMemoryRequirements)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetImageSparseMemoryRequirements(device, image, pSparseMemoryRequirementCount, pSparseMemoryRequirements);
      }
      VkResult __attribute__ ((weak))
      lvp_QueueBindSparse(VkQueue queue, uint32_t bindInfoCount, const VkBindSparseInfo* pBindInfo, VkFence fence)
      {
          LVP_FROM_HANDLE(lvp_queue, lvp_queue, queue);
          return lvp_queue->device->dispatch.vkQueueBindSparse(queue, bindInfoCount, pBindInfo, fence);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateFence(VkDevice device, const VkFenceCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkFence* pFence)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateFence(device, pCreateInfo, pAllocator, pFence);
      }
      void __attribute__ ((weak))
      lvp_DestroyFence(VkDevice device, VkFence fence, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyFence(device, fence, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_ResetFences(VkDevice device, uint32_t fenceCount, const VkFence* pFences)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkResetFences(device, fenceCount, pFences);
      }
      VkResult __attribute__ ((weak))
      lvp_GetFenceStatus(VkDevice device, VkFence fence)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetFenceStatus(device, fence);
      }
      VkResult __attribute__ ((weak))
      lvp_WaitForFences(VkDevice device, uint32_t fenceCount, const VkFence* pFences, VkBool32 waitAll, uint64_t timeout)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkWaitForFences(device, fenceCount, pFences, waitAll, timeout);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateSemaphore(VkDevice device, const VkSemaphoreCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSemaphore* pSemaphore)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateSemaphore(device, pCreateInfo, pAllocator, pSemaphore);
      }
      void __attribute__ ((weak))
      lvp_DestroySemaphore(VkDevice device, VkSemaphore semaphore, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroySemaphore(device, semaphore, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateEvent(VkDevice device, const VkEventCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkEvent* pEvent)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateEvent(device, pCreateInfo, pAllocator, pEvent);
      }
      void __attribute__ ((weak))
      lvp_DestroyEvent(VkDevice device, VkEvent event, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyEvent(device, event, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_GetEventStatus(VkDevice device, VkEvent event)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetEventStatus(device, event);
      }
      VkResult __attribute__ ((weak))
      lvp_SetEvent(VkDevice device, VkEvent event)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkSetEvent(device, event);
      }
      VkResult __attribute__ ((weak))
      lvp_ResetEvent(VkDevice device, VkEvent event)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkResetEvent(device, event);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateQueryPool(VkDevice device, const VkQueryPoolCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkQueryPool* pQueryPool)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateQueryPool(device, pCreateInfo, pAllocator, pQueryPool);
      }
      void __attribute__ ((weak))
      lvp_DestroyQueryPool(VkDevice device, VkQueryPool queryPool, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyQueryPool(device, queryPool, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_GetQueryPoolResults(VkDevice device, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount, size_t dataSize, void* pData, VkDeviceSize stride, VkQueryResultFlags flags)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetQueryPoolResults(device, queryPool, firstQuery, queryCount, dataSize, pData, stride, flags);
      }
      void __attribute__ ((weak))
      lvp_ResetQueryPool(VkDevice device, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkResetQueryPool(device, queryPool, firstQuery, queryCount);
      }
            VkResult __attribute__ ((weak))
      lvp_CreateBuffer(VkDevice device, const VkBufferCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkBuffer* pBuffer)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateBuffer(device, pCreateInfo, pAllocator, pBuffer);
      }
      void __attribute__ ((weak))
      lvp_DestroyBuffer(VkDevice device, VkBuffer buffer, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyBuffer(device, buffer, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateBufferView(VkDevice device, const VkBufferViewCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkBufferView* pView)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateBufferView(device, pCreateInfo, pAllocator, pView);
      }
      void __attribute__ ((weak))
      lvp_DestroyBufferView(VkDevice device, VkBufferView bufferView, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyBufferView(device, bufferView, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateImage(VkDevice device, const VkImageCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkImage* pImage)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateImage(device, pCreateInfo, pAllocator, pImage);
      }
      void __attribute__ ((weak))
      lvp_DestroyImage(VkDevice device, VkImage image, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyImage(device, image, pAllocator);
      }
      void __attribute__ ((weak))
      lvp_GetImageSubresourceLayout(VkDevice device, VkImage image, const VkImageSubresource* pSubresource, VkSubresourceLayout* pLayout)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetImageSubresourceLayout(device, image, pSubresource, pLayout);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateImageView(VkDevice device, const VkImageViewCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkImageView* pView)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateImageView(device, pCreateInfo, pAllocator, pView);
      }
      void __attribute__ ((weak))
      lvp_DestroyImageView(VkDevice device, VkImageView imageView, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyImageView(device, imageView, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateShaderModule(VkDevice device, const VkShaderModuleCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkShaderModule* pShaderModule)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateShaderModule(device, pCreateInfo, pAllocator, pShaderModule);
      }
      void __attribute__ ((weak))
      lvp_DestroyShaderModule(VkDevice device, VkShaderModule shaderModule, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyShaderModule(device, shaderModule, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreatePipelineCache(VkDevice device, const VkPipelineCacheCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkPipelineCache* pPipelineCache)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreatePipelineCache(device, pCreateInfo, pAllocator, pPipelineCache);
      }
      void __attribute__ ((weak))
      lvp_DestroyPipelineCache(VkDevice device, VkPipelineCache pipelineCache, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyPipelineCache(device, pipelineCache, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_GetPipelineCacheData(VkDevice device, VkPipelineCache pipelineCache, size_t* pDataSize, void* pData)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetPipelineCacheData(device, pipelineCache, pDataSize, pData);
      }
      VkResult __attribute__ ((weak))
      lvp_MergePipelineCaches(VkDevice device, VkPipelineCache dstCache, uint32_t srcCacheCount, const VkPipelineCache* pSrcCaches)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkMergePipelineCaches(device, dstCache, srcCacheCount, pSrcCaches);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateGraphicsPipelines(VkDevice device, VkPipelineCache pipelineCache, uint32_t createInfoCount, const VkGraphicsPipelineCreateInfo* pCreateInfos, const VkAllocationCallbacks* pAllocator, VkPipeline* pPipelines)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateGraphicsPipelines(device, pipelineCache, createInfoCount, pCreateInfos, pAllocator, pPipelines);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateComputePipelines(VkDevice device, VkPipelineCache pipelineCache, uint32_t createInfoCount, const VkComputePipelineCreateInfo* pCreateInfos, const VkAllocationCallbacks* pAllocator, VkPipeline* pPipelines)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateComputePipelines(device, pipelineCache, createInfoCount, pCreateInfos, pAllocator, pPipelines);
      }
      void __attribute__ ((weak))
      lvp_DestroyPipeline(VkDevice device, VkPipeline pipeline, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyPipeline(device, pipeline, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreatePipelineLayout(VkDevice device, const VkPipelineLayoutCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkPipelineLayout* pPipelineLayout)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreatePipelineLayout(device, pCreateInfo, pAllocator, pPipelineLayout);
      }
      void __attribute__ ((weak))
      lvp_DestroyPipelineLayout(VkDevice device, VkPipelineLayout pipelineLayout, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyPipelineLayout(device, pipelineLayout, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateSampler(VkDevice device, const VkSamplerCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSampler* pSampler)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateSampler(device, pCreateInfo, pAllocator, pSampler);
      }
      void __attribute__ ((weak))
      lvp_DestroySampler(VkDevice device, VkSampler sampler, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroySampler(device, sampler, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateDescriptorSetLayout(VkDevice device, const VkDescriptorSetLayoutCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDescriptorSetLayout* pSetLayout)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateDescriptorSetLayout(device, pCreateInfo, pAllocator, pSetLayout);
      }
      void __attribute__ ((weak))
      lvp_DestroyDescriptorSetLayout(VkDevice device, VkDescriptorSetLayout descriptorSetLayout, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyDescriptorSetLayout(device, descriptorSetLayout, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateDescriptorPool(VkDevice device, const VkDescriptorPoolCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDescriptorPool* pDescriptorPool)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateDescriptorPool(device, pCreateInfo, pAllocator, pDescriptorPool);
      }
      void __attribute__ ((weak))
      lvp_DestroyDescriptorPool(VkDevice device, VkDescriptorPool descriptorPool, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyDescriptorPool(device, descriptorPool, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_ResetDescriptorPool(VkDevice device, VkDescriptorPool descriptorPool, VkDescriptorPoolResetFlags flags)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkResetDescriptorPool(device, descriptorPool, flags);
      }
      VkResult __attribute__ ((weak))
      lvp_AllocateDescriptorSets(VkDevice device, const VkDescriptorSetAllocateInfo* pAllocateInfo, VkDescriptorSet* pDescriptorSets)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkAllocateDescriptorSets(device, pAllocateInfo, pDescriptorSets);
      }
      VkResult __attribute__ ((weak))
      lvp_FreeDescriptorSets(VkDevice device, VkDescriptorPool descriptorPool, uint32_t descriptorSetCount, const VkDescriptorSet* pDescriptorSets)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkFreeDescriptorSets(device, descriptorPool, descriptorSetCount, pDescriptorSets);
      }
      void __attribute__ ((weak))
      lvp_UpdateDescriptorSets(VkDevice device, uint32_t descriptorWriteCount, const VkWriteDescriptorSet* pDescriptorWrites, uint32_t descriptorCopyCount, const VkCopyDescriptorSet* pDescriptorCopies)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkUpdateDescriptorSets(device, descriptorWriteCount, pDescriptorWrites, descriptorCopyCount, pDescriptorCopies);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateFramebuffer(VkDevice device, const VkFramebufferCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkFramebuffer* pFramebuffer)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateFramebuffer(device, pCreateInfo, pAllocator, pFramebuffer);
      }
      void __attribute__ ((weak))
      lvp_DestroyFramebuffer(VkDevice device, VkFramebuffer framebuffer, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyFramebuffer(device, framebuffer, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateRenderPass(VkDevice device, const VkRenderPassCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkRenderPass* pRenderPass)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateRenderPass(device, pCreateInfo, pAllocator, pRenderPass);
      }
      void __attribute__ ((weak))
      lvp_DestroyRenderPass(VkDevice device, VkRenderPass renderPass, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyRenderPass(device, renderPass, pAllocator);
      }
      void __attribute__ ((weak))
      lvp_GetRenderAreaGranularity(VkDevice device, VkRenderPass renderPass, VkExtent2D* pGranularity)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetRenderAreaGranularity(device, renderPass, pGranularity);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateCommandPool(VkDevice device, const VkCommandPoolCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkCommandPool* pCommandPool)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateCommandPool(device, pCreateInfo, pAllocator, pCommandPool);
      }
      void __attribute__ ((weak))
      lvp_DestroyCommandPool(VkDevice device, VkCommandPool commandPool, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyCommandPool(device, commandPool, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_ResetCommandPool(VkDevice device, VkCommandPool commandPool, VkCommandPoolResetFlags flags)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkResetCommandPool(device, commandPool, flags);
      }
      VkResult __attribute__ ((weak))
      lvp_AllocateCommandBuffers(VkDevice device, const VkCommandBufferAllocateInfo* pAllocateInfo, VkCommandBuffer* pCommandBuffers)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkAllocateCommandBuffers(device, pAllocateInfo, pCommandBuffers);
      }
      void __attribute__ ((weak))
      lvp_FreeCommandBuffers(VkDevice device, VkCommandPool commandPool, uint32_t commandBufferCount, const VkCommandBuffer* pCommandBuffers)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkFreeCommandBuffers(device, commandPool, commandBufferCount, pCommandBuffers);
      }
      VkResult __attribute__ ((weak))
      lvp_BeginCommandBuffer(VkCommandBuffer commandBuffer, const VkCommandBufferBeginInfo* pBeginInfo)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkBeginCommandBuffer(commandBuffer, pBeginInfo);
      }
      VkResult __attribute__ ((weak))
      lvp_EndCommandBuffer(VkCommandBuffer commandBuffer)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkEndCommandBuffer(commandBuffer);
      }
      VkResult __attribute__ ((weak))
      lvp_ResetCommandBuffer(VkCommandBuffer commandBuffer, VkCommandBufferResetFlags flags)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkResetCommandBuffer(commandBuffer, flags);
      }
      void __attribute__ ((weak))
      lvp_CmdBindPipeline(VkCommandBuffer commandBuffer, VkPipelineBindPoint pipelineBindPoint, VkPipeline pipeline)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBindPipeline(commandBuffer, pipelineBindPoint, pipeline);
      }
      void __attribute__ ((weak))
      lvp_CmdSetViewport(VkCommandBuffer commandBuffer, uint32_t firstViewport, uint32_t viewportCount, const VkViewport* pViewports)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetViewport(commandBuffer, firstViewport, viewportCount, pViewports);
      }
      void __attribute__ ((weak))
      lvp_CmdSetScissor(VkCommandBuffer commandBuffer, uint32_t firstScissor, uint32_t scissorCount, const VkRect2D* pScissors)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetScissor(commandBuffer, firstScissor, scissorCount, pScissors);
      }
      void __attribute__ ((weak))
      lvp_CmdSetLineWidth(VkCommandBuffer commandBuffer, float lineWidth)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetLineWidth(commandBuffer, lineWidth);
      }
      void __attribute__ ((weak))
      lvp_CmdSetDepthBias(VkCommandBuffer commandBuffer, float depthBiasConstantFactor, float depthBiasClamp, float depthBiasSlopeFactor)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetDepthBias(commandBuffer, depthBiasConstantFactor, depthBiasClamp, depthBiasSlopeFactor);
      }
      void __attribute__ ((weak))
      lvp_CmdSetBlendConstants(VkCommandBuffer commandBuffer, const float blendConstants[4])
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetBlendConstants(commandBuffer, blendConstants);
      }
      void __attribute__ ((weak))
      lvp_CmdSetDepthBounds(VkCommandBuffer commandBuffer, float minDepthBounds, float maxDepthBounds)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetDepthBounds(commandBuffer, minDepthBounds, maxDepthBounds);
      }
      void __attribute__ ((weak))
      lvp_CmdSetStencilCompareMask(VkCommandBuffer commandBuffer, VkStencilFaceFlags faceMask, uint32_t compareMask)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetStencilCompareMask(commandBuffer, faceMask, compareMask);
      }
      void __attribute__ ((weak))
      lvp_CmdSetStencilWriteMask(VkCommandBuffer commandBuffer, VkStencilFaceFlags faceMask, uint32_t writeMask)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetStencilWriteMask(commandBuffer, faceMask, writeMask);
      }
      void __attribute__ ((weak))
      lvp_CmdSetStencilReference(VkCommandBuffer commandBuffer, VkStencilFaceFlags faceMask, uint32_t reference)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetStencilReference(commandBuffer, faceMask, reference);
      }
      void __attribute__ ((weak))
      lvp_CmdBindDescriptorSets(VkCommandBuffer commandBuffer, VkPipelineBindPoint pipelineBindPoint, VkPipelineLayout layout, uint32_t firstSet, uint32_t descriptorSetCount, const VkDescriptorSet* pDescriptorSets, uint32_t dynamicOffsetCount, const uint32_t* pDynamicOffsets)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBindDescriptorSets(commandBuffer, pipelineBindPoint, layout, firstSet, descriptorSetCount, pDescriptorSets, dynamicOffsetCount, pDynamicOffsets);
      }
      void __attribute__ ((weak))
      lvp_CmdBindIndexBuffer(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, VkIndexType indexType)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBindIndexBuffer(commandBuffer, buffer, offset, indexType);
      }
      void __attribute__ ((weak))
      lvp_CmdBindVertexBuffers(VkCommandBuffer commandBuffer, uint32_t firstBinding, uint32_t bindingCount, const VkBuffer* pBuffers, const VkDeviceSize* pOffsets)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBindVertexBuffers(commandBuffer, firstBinding, bindingCount, pBuffers, pOffsets);
      }
      void __attribute__ ((weak))
      lvp_CmdDraw(VkCommandBuffer commandBuffer, uint32_t vertexCount, uint32_t instanceCount, uint32_t firstVertex, uint32_t firstInstance)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDraw(commandBuffer, vertexCount, instanceCount, firstVertex, firstInstance);
      }
      void __attribute__ ((weak))
      lvp_CmdDrawIndexed(VkCommandBuffer commandBuffer, uint32_t indexCount, uint32_t instanceCount, uint32_t firstIndex, int32_t vertexOffset, uint32_t firstInstance)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDrawIndexed(commandBuffer, indexCount, instanceCount, firstIndex, vertexOffset, firstInstance);
      }
      void __attribute__ ((weak))
      lvp_CmdDrawIndirect(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, uint32_t drawCount, uint32_t stride)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDrawIndirect(commandBuffer, buffer, offset, drawCount, stride);
      }
      void __attribute__ ((weak))
      lvp_CmdDrawIndexedIndirect(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, uint32_t drawCount, uint32_t stride)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDrawIndexedIndirect(commandBuffer, buffer, offset, drawCount, stride);
      }
      void __attribute__ ((weak))
      lvp_CmdDispatch(VkCommandBuffer commandBuffer, uint32_t groupCountX, uint32_t groupCountY, uint32_t groupCountZ)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDispatch(commandBuffer, groupCountX, groupCountY, groupCountZ);
      }
      void __attribute__ ((weak))
      lvp_CmdDispatchIndirect(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDispatchIndirect(commandBuffer, buffer, offset);
      }
      void __attribute__ ((weak))
      lvp_CmdCopyBuffer(VkCommandBuffer commandBuffer, VkBuffer srcBuffer, VkBuffer dstBuffer, uint32_t regionCount, const VkBufferCopy* pRegions)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdCopyBuffer(commandBuffer, srcBuffer, dstBuffer, regionCount, pRegions);
      }
      void __attribute__ ((weak))
      lvp_CmdCopyImage(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkImageCopy* pRegions)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdCopyImage(commandBuffer, srcImage, srcImageLayout, dstImage, dstImageLayout, regionCount, pRegions);
      }
      void __attribute__ ((weak))
      lvp_CmdBlitImage(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkImageBlit* pRegions, VkFilter filter)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBlitImage(commandBuffer, srcImage, srcImageLayout, dstImage, dstImageLayout, regionCount, pRegions, filter);
      }
      void __attribute__ ((weak))
      lvp_CmdCopyBufferToImage(VkCommandBuffer commandBuffer, VkBuffer srcBuffer, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkBufferImageCopy* pRegions)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdCopyBufferToImage(commandBuffer, srcBuffer, dstImage, dstImageLayout, regionCount, pRegions);
      }
      void __attribute__ ((weak))
      lvp_CmdCopyImageToBuffer(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkBuffer dstBuffer, uint32_t regionCount, const VkBufferImageCopy* pRegions)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdCopyImageToBuffer(commandBuffer, srcImage, srcImageLayout, dstBuffer, regionCount, pRegions);
      }
      void __attribute__ ((weak))
      lvp_CmdUpdateBuffer(VkCommandBuffer commandBuffer, VkBuffer dstBuffer, VkDeviceSize dstOffset, VkDeviceSize dataSize, const void* pData)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdUpdateBuffer(commandBuffer, dstBuffer, dstOffset, dataSize, pData);
      }
      void __attribute__ ((weak))
      lvp_CmdFillBuffer(VkCommandBuffer commandBuffer, VkBuffer dstBuffer, VkDeviceSize dstOffset, VkDeviceSize size, uint32_t data)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdFillBuffer(commandBuffer, dstBuffer, dstOffset, size, data);
      }
      void __attribute__ ((weak))
      lvp_CmdClearColorImage(VkCommandBuffer commandBuffer, VkImage image, VkImageLayout imageLayout, const VkClearColorValue* pColor, uint32_t rangeCount, const VkImageSubresourceRange* pRanges)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdClearColorImage(commandBuffer, image, imageLayout, pColor, rangeCount, pRanges);
      }
      void __attribute__ ((weak))
      lvp_CmdClearDepthStencilImage(VkCommandBuffer commandBuffer, VkImage image, VkImageLayout imageLayout, const VkClearDepthStencilValue* pDepthStencil, uint32_t rangeCount, const VkImageSubresourceRange* pRanges)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdClearDepthStencilImage(commandBuffer, image, imageLayout, pDepthStencil, rangeCount, pRanges);
      }
      void __attribute__ ((weak))
      lvp_CmdClearAttachments(VkCommandBuffer commandBuffer, uint32_t attachmentCount, const VkClearAttachment* pAttachments, uint32_t rectCount, const VkClearRect* pRects)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdClearAttachments(commandBuffer, attachmentCount, pAttachments, rectCount, pRects);
      }
      void __attribute__ ((weak))
      lvp_CmdResolveImage(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkImageResolve* pRegions)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdResolveImage(commandBuffer, srcImage, srcImageLayout, dstImage, dstImageLayout, regionCount, pRegions);
      }
      void __attribute__ ((weak))
      lvp_CmdSetEvent(VkCommandBuffer commandBuffer, VkEvent event, VkPipelineStageFlags stageMask)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetEvent(commandBuffer, event, stageMask);
      }
      void __attribute__ ((weak))
      lvp_CmdResetEvent(VkCommandBuffer commandBuffer, VkEvent event, VkPipelineStageFlags stageMask)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdResetEvent(commandBuffer, event, stageMask);
      }
      void __attribute__ ((weak))
      lvp_CmdWaitEvents(VkCommandBuffer commandBuffer, uint32_t eventCount, const VkEvent* pEvents, VkPipelineStageFlags srcStageMask, VkPipelineStageFlags dstStageMask, uint32_t memoryBarrierCount, const VkMemoryBarrier* pMemoryBarriers, uint32_t bufferMemoryBarrierCount, const VkBufferMemoryBarrier* pBufferMemoryBarriers, uint32_t imageMemoryBarrierCount, const VkImageMemoryBarrier* pImageMemoryBarriers)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdWaitEvents(commandBuffer, eventCount, pEvents, srcStageMask, dstStageMask, memoryBarrierCount, pMemoryBarriers, bufferMemoryBarrierCount, pBufferMemoryBarriers, imageMemoryBarrierCount, pImageMemoryBarriers);
      }
      void __attribute__ ((weak))
      lvp_CmdPipelineBarrier(VkCommandBuffer commandBuffer, VkPipelineStageFlags srcStageMask, VkPipelineStageFlags dstStageMask, VkDependencyFlags dependencyFlags, uint32_t memoryBarrierCount, const VkMemoryBarrier* pMemoryBarriers, uint32_t bufferMemoryBarrierCount, const VkBufferMemoryBarrier* pBufferMemoryBarriers, uint32_t imageMemoryBarrierCount, const VkImageMemoryBarrier* pImageMemoryBarriers)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdPipelineBarrier(commandBuffer, srcStageMask, dstStageMask, dependencyFlags, memoryBarrierCount, pMemoryBarriers, bufferMemoryBarrierCount, pBufferMemoryBarriers, imageMemoryBarrierCount, pImageMemoryBarriers);
      }
      void __attribute__ ((weak))
      lvp_CmdBeginQuery(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query, VkQueryControlFlags flags)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBeginQuery(commandBuffer, queryPool, query, flags);
      }
      void __attribute__ ((weak))
      lvp_CmdEndQuery(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdEndQuery(commandBuffer, queryPool, query);
      }
      void __attribute__ ((weak))
      lvp_CmdBeginConditionalRenderingEXT(VkCommandBuffer commandBuffer, const VkConditionalRenderingBeginInfoEXT* pConditionalRenderingBegin)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBeginConditionalRenderingEXT(commandBuffer, pConditionalRenderingBegin);
      }
      void __attribute__ ((weak))
      lvp_CmdEndConditionalRenderingEXT(VkCommandBuffer commandBuffer)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdEndConditionalRenderingEXT(commandBuffer);
      }
      void __attribute__ ((weak))
      lvp_CmdResetQueryPool(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdResetQueryPool(commandBuffer, queryPool, firstQuery, queryCount);
      }
      void __attribute__ ((weak))
      lvp_CmdWriteTimestamp(VkCommandBuffer commandBuffer, VkPipelineStageFlagBits pipelineStage, VkQueryPool queryPool, uint32_t query)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdWriteTimestamp(commandBuffer, pipelineStage, queryPool, query);
      }
      void __attribute__ ((weak))
      lvp_CmdCopyQueryPoolResults(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount, VkBuffer dstBuffer, VkDeviceSize dstOffset, VkDeviceSize stride, VkQueryResultFlags flags)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdCopyQueryPoolResults(commandBuffer, queryPool, firstQuery, queryCount, dstBuffer, dstOffset, stride, flags);
      }
      void __attribute__ ((weak))
      lvp_CmdPushConstants(VkCommandBuffer commandBuffer, VkPipelineLayout layout, VkShaderStageFlags stageFlags, uint32_t offset, uint32_t size, const void* pValues)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdPushConstants(commandBuffer, layout, stageFlags, offset, size, pValues);
      }
      void __attribute__ ((weak))
      lvp_CmdBeginRenderPass(VkCommandBuffer commandBuffer, const VkRenderPassBeginInfo* pRenderPassBegin, VkSubpassContents contents)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBeginRenderPass(commandBuffer, pRenderPassBegin, contents);
      }
      void __attribute__ ((weak))
      lvp_CmdNextSubpass(VkCommandBuffer commandBuffer, VkSubpassContents contents)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdNextSubpass(commandBuffer, contents);
      }
      void __attribute__ ((weak))
      lvp_CmdEndRenderPass(VkCommandBuffer commandBuffer)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdEndRenderPass(commandBuffer);
      }
      void __attribute__ ((weak))
      lvp_CmdExecuteCommands(VkCommandBuffer commandBuffer, uint32_t commandBufferCount, const VkCommandBuffer* pCommandBuffers)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdExecuteCommands(commandBuffer, commandBufferCount, pCommandBuffers);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateSwapchainKHR(VkDevice device, const VkSwapchainCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSwapchainKHR* pSwapchain)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateSwapchainKHR(device, pCreateInfo, pAllocator, pSwapchain);
      }
      void __attribute__ ((weak))
      lvp_DestroySwapchainKHR(VkDevice device, VkSwapchainKHR swapchain, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroySwapchainKHR(device, swapchain, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_GetSwapchainImagesKHR(VkDevice device, VkSwapchainKHR swapchain, uint32_t* pSwapchainImageCount, VkImage* pSwapchainImages)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetSwapchainImagesKHR(device, swapchain, pSwapchainImageCount, pSwapchainImages);
      }
      VkResult __attribute__ ((weak))
      lvp_AcquireNextImageKHR(VkDevice device, VkSwapchainKHR swapchain, uint64_t timeout, VkSemaphore semaphore, VkFence fence, uint32_t* pImageIndex)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkAcquireNextImageKHR(device, swapchain, timeout, semaphore, fence, pImageIndex);
      }
      VkResult __attribute__ ((weak))
      lvp_QueuePresentKHR(VkQueue queue, const VkPresentInfoKHR* pPresentInfo)
      {
          LVP_FROM_HANDLE(lvp_queue, lvp_queue, queue);
          return lvp_queue->device->dispatch.vkQueuePresentKHR(queue, pPresentInfo);
      }
      void __attribute__ ((weak))
      lvp_CmdPushDescriptorSetKHR(VkCommandBuffer commandBuffer, VkPipelineBindPoint pipelineBindPoint, VkPipelineLayout layout, uint32_t set, uint32_t descriptorWriteCount, const VkWriteDescriptorSet* pDescriptorWrites)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdPushDescriptorSetKHR(commandBuffer, pipelineBindPoint, layout, set, descriptorWriteCount, pDescriptorWrites);
      }
      void __attribute__ ((weak))
      lvp_TrimCommandPool(VkDevice device, VkCommandPool commandPool, VkCommandPoolTrimFlags flags)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkTrimCommandPool(device, commandPool, flags);
      }
            VkResult __attribute__ ((weak))
      lvp_GetMemoryFdKHR(VkDevice device, const VkMemoryGetFdInfoKHR* pGetFdInfo, int* pFd)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetMemoryFdKHR(device, pGetFdInfo, pFd);
      }
      VkResult __attribute__ ((weak))
      lvp_GetMemoryFdPropertiesKHR(VkDevice device, VkExternalMemoryHandleTypeFlagBits handleType, int fd, VkMemoryFdPropertiesKHR* pMemoryFdProperties)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetMemoryFdPropertiesKHR(device, handleType, fd, pMemoryFdProperties);
      }
      VkResult __attribute__ ((weak))
      lvp_GetSemaphoreFdKHR(VkDevice device, const VkSemaphoreGetFdInfoKHR* pGetFdInfo, int* pFd)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetSemaphoreFdKHR(device, pGetFdInfo, pFd);
      }
      VkResult __attribute__ ((weak))
      lvp_ImportSemaphoreFdKHR(VkDevice device, const VkImportSemaphoreFdInfoKHR* pImportSemaphoreFdInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkImportSemaphoreFdKHR(device, pImportSemaphoreFdInfo);
      }
      VkResult __attribute__ ((weak))
      lvp_GetFenceFdKHR(VkDevice device, const VkFenceGetFdInfoKHR* pGetFdInfo, int* pFd)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetFenceFdKHR(device, pGetFdInfo, pFd);
      }
      VkResult __attribute__ ((weak))
      lvp_ImportFenceFdKHR(VkDevice device, const VkImportFenceFdInfoKHR* pImportFenceFdInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkImportFenceFdKHR(device, pImportFenceFdInfo);
      }
      VkResult __attribute__ ((weak))
      lvp_DisplayPowerControlEXT(VkDevice device, VkDisplayKHR display, const VkDisplayPowerInfoEXT* pDisplayPowerInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDisplayPowerControlEXT(device, display, pDisplayPowerInfo);
      }
      VkResult __attribute__ ((weak))
      lvp_RegisterDeviceEventEXT(VkDevice device, const VkDeviceEventInfoEXT* pDeviceEventInfo, const VkAllocationCallbacks* pAllocator, VkFence* pFence)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkRegisterDeviceEventEXT(device, pDeviceEventInfo, pAllocator, pFence);
      }
      VkResult __attribute__ ((weak))
      lvp_RegisterDisplayEventEXT(VkDevice device, VkDisplayKHR display, const VkDisplayEventInfoEXT* pDisplayEventInfo, const VkAllocationCallbacks* pAllocator, VkFence* pFence)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkRegisterDisplayEventEXT(device, display, pDisplayEventInfo, pAllocator, pFence);
      }
      VkResult __attribute__ ((weak))
      lvp_GetSwapchainCounterEXT(VkDevice device, VkSwapchainKHR swapchain, VkSurfaceCounterFlagBitsEXT counter, uint64_t* pCounterValue)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetSwapchainCounterEXT(device, swapchain, counter, pCounterValue);
      }
      void __attribute__ ((weak))
      lvp_GetDeviceGroupPeerMemoryFeatures(VkDevice device, uint32_t heapIndex, uint32_t localDeviceIndex, uint32_t remoteDeviceIndex, VkPeerMemoryFeatureFlags* pPeerMemoryFeatures)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceGroupPeerMemoryFeatures(device, heapIndex, localDeviceIndex, remoteDeviceIndex, pPeerMemoryFeatures);
      }
            VkResult __attribute__ ((weak))
      lvp_BindBufferMemory2(VkDevice device, uint32_t bindInfoCount, const VkBindBufferMemoryInfo* pBindInfos)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkBindBufferMemory2(device, bindInfoCount, pBindInfos);
      }
            VkResult __attribute__ ((weak))
      lvp_BindImageMemory2(VkDevice device, uint32_t bindInfoCount, const VkBindImageMemoryInfo* pBindInfos)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkBindImageMemory2(device, bindInfoCount, pBindInfos);
      }
            void __attribute__ ((weak))
      lvp_CmdSetDeviceMask(VkCommandBuffer commandBuffer, uint32_t deviceMask)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetDeviceMask(commandBuffer, deviceMask);
      }
            VkResult __attribute__ ((weak))
      lvp_GetDeviceGroupPresentCapabilitiesKHR(VkDevice device, VkDeviceGroupPresentCapabilitiesKHR* pDeviceGroupPresentCapabilities)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceGroupPresentCapabilitiesKHR(device, pDeviceGroupPresentCapabilities);
      }
      VkResult __attribute__ ((weak))
      lvp_GetDeviceGroupSurfacePresentModesKHR(VkDevice device, VkSurfaceKHR surface, VkDeviceGroupPresentModeFlagsKHR* pModes)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceGroupSurfacePresentModesKHR(device, surface, pModes);
      }
      VkResult __attribute__ ((weak))
      lvp_AcquireNextImage2KHR(VkDevice device, const VkAcquireNextImageInfoKHR* pAcquireInfo, uint32_t* pImageIndex)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkAcquireNextImage2KHR(device, pAcquireInfo, pImageIndex);
      }
      void __attribute__ ((weak))
      lvp_CmdDispatchBase(VkCommandBuffer commandBuffer, uint32_t baseGroupX, uint32_t baseGroupY, uint32_t baseGroupZ, uint32_t groupCountX, uint32_t groupCountY, uint32_t groupCountZ)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDispatchBase(commandBuffer, baseGroupX, baseGroupY, baseGroupZ, groupCountX, groupCountY, groupCountZ);
      }
            VkResult __attribute__ ((weak))
      lvp_CreateDescriptorUpdateTemplate(VkDevice device, const VkDescriptorUpdateTemplateCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDescriptorUpdateTemplate* pDescriptorUpdateTemplate)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateDescriptorUpdateTemplate(device, pCreateInfo, pAllocator, pDescriptorUpdateTemplate);
      }
            void __attribute__ ((weak))
      lvp_DestroyDescriptorUpdateTemplate(VkDevice device, VkDescriptorUpdateTemplate descriptorUpdateTemplate, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyDescriptorUpdateTemplate(device, descriptorUpdateTemplate, pAllocator);
      }
            void __attribute__ ((weak))
      lvp_UpdateDescriptorSetWithTemplate(VkDevice device, VkDescriptorSet descriptorSet, VkDescriptorUpdateTemplate descriptorUpdateTemplate, const void* pData)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkUpdateDescriptorSetWithTemplate(device, descriptorSet, descriptorUpdateTemplate, pData);
      }
            void __attribute__ ((weak))
      lvp_CmdPushDescriptorSetWithTemplateKHR(VkCommandBuffer commandBuffer, VkDescriptorUpdateTemplate descriptorUpdateTemplate, VkPipelineLayout layout, uint32_t set, const void* pData)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdPushDescriptorSetWithTemplateKHR(commandBuffer, descriptorUpdateTemplate, layout, set, pData);
      }
      void __attribute__ ((weak))
      lvp_CmdSetDiscardRectangleEXT(VkCommandBuffer commandBuffer, uint32_t firstDiscardRectangle, uint32_t discardRectangleCount, const VkRect2D* pDiscardRectangles)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetDiscardRectangleEXT(commandBuffer, firstDiscardRectangle, discardRectangleCount, pDiscardRectangles);
      }
      void __attribute__ ((weak))
      lvp_CmdSetSampleLocationsEXT(VkCommandBuffer commandBuffer, const VkSampleLocationsInfoEXT* pSampleLocationsInfo)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdSetSampleLocationsEXT(commandBuffer, pSampleLocationsInfo);
      }
      void __attribute__ ((weak))
      lvp_GetBufferMemoryRequirements2(VkDevice device, const VkBufferMemoryRequirementsInfo2* pInfo, VkMemoryRequirements2* pMemoryRequirements)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetBufferMemoryRequirements2(device, pInfo, pMemoryRequirements);
      }
            void __attribute__ ((weak))
      lvp_GetImageMemoryRequirements2(VkDevice device, const VkImageMemoryRequirementsInfo2* pInfo, VkMemoryRequirements2* pMemoryRequirements)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetImageMemoryRequirements2(device, pInfo, pMemoryRequirements);
      }
            void __attribute__ ((weak))
      lvp_GetImageSparseMemoryRequirements2(VkDevice device, const VkImageSparseMemoryRequirementsInfo2* pInfo, uint32_t* pSparseMemoryRequirementCount, VkSparseImageMemoryRequirements2* pSparseMemoryRequirements)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetImageSparseMemoryRequirements2(device, pInfo, pSparseMemoryRequirementCount, pSparseMemoryRequirements);
      }
            VkResult __attribute__ ((weak))
      lvp_CreateSamplerYcbcrConversion(VkDevice device, const VkSamplerYcbcrConversionCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSamplerYcbcrConversion* pYcbcrConversion)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateSamplerYcbcrConversion(device, pCreateInfo, pAllocator, pYcbcrConversion);
      }
            void __attribute__ ((weak))
      lvp_DestroySamplerYcbcrConversion(VkDevice device, VkSamplerYcbcrConversion ycbcrConversion, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroySamplerYcbcrConversion(device, ycbcrConversion, pAllocator);
      }
            void __attribute__ ((weak))
      lvp_GetDeviceQueue2(VkDevice device, const VkDeviceQueueInfo2* pQueueInfo, VkQueue* pQueue)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceQueue2(device, pQueueInfo, pQueue);
      }
      void __attribute__ ((weak))
      lvp_GetDescriptorSetLayoutSupport(VkDevice device, const VkDescriptorSetLayoutCreateInfo* pCreateInfo, VkDescriptorSetLayoutSupport* pSupport)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDescriptorSetLayoutSupport(device, pCreateInfo, pSupport);
      }
      #ifdef VK_USE_PLATFORM_ANDROID_KHR
      VkResult __attribute__ ((weak))
      lvp_GetSwapchainGrallocUsageANDROID(VkDevice device, VkFormat format, VkImageUsageFlags imageUsage, int* grallocUsage)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetSwapchainGrallocUsageANDROID(device, format, imageUsage, grallocUsage);
      }
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
      VkResult __attribute__ ((weak))
      lvp_GetSwapchainGrallocUsage2ANDROID(VkDevice device, VkFormat format, VkImageUsageFlags imageUsage, VkSwapchainImageUsageFlagsANDROID swapchainImageUsage, uint64_t* grallocConsumerUsage, uint64_t* grallocProducerUsage)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetSwapchainGrallocUsage2ANDROID(device, format, imageUsage, swapchainImageUsage, grallocConsumerUsage, grallocProducerUsage);
      }
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
      VkResult __attribute__ ((weak))
      lvp_AcquireImageANDROID(VkDevice device, VkImage image, int nativeFenceFd, VkSemaphore semaphore, VkFence fence)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkAcquireImageANDROID(device, image, nativeFenceFd, semaphore, fence);
      }
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
      VkResult __attribute__ ((weak))
      lvp_QueueSignalReleaseImageANDROID(VkQueue queue, uint32_t waitSemaphoreCount, const VkSemaphore* pWaitSemaphores, VkImage image, int* pNativeFenceFd)
      {
          LVP_FROM_HANDLE(lvp_queue, lvp_queue, queue);
          return lvp_queue->device->dispatch.vkQueueSignalReleaseImageANDROID(queue, waitSemaphoreCount, pWaitSemaphores, image, pNativeFenceFd);
      }
#endif // VK_USE_PLATFORM_ANDROID_KHR
      VkResult __attribute__ ((weak))
      lvp_GetCalibratedTimestampsEXT(VkDevice device, uint32_t timestampCount, const VkCalibratedTimestampInfoEXT* pTimestampInfos, uint64_t* pTimestamps, uint64_t* pMaxDeviation)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetCalibratedTimestampsEXT(device, timestampCount, pTimestampInfos, pTimestamps, pMaxDeviation);
      }
      VkResult __attribute__ ((weak))
      lvp_GetMemoryHostPointerPropertiesEXT(VkDevice device, VkExternalMemoryHandleTypeFlagBits handleType, const void* pHostPointer, VkMemoryHostPointerPropertiesEXT* pMemoryHostPointerProperties)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetMemoryHostPointerPropertiesEXT(device, handleType, pHostPointer, pMemoryHostPointerProperties);
      }
      VkResult __attribute__ ((weak))
      lvp_CreateRenderPass2(VkDevice device, const VkRenderPassCreateInfo2* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkRenderPass* pRenderPass)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreateRenderPass2(device, pCreateInfo, pAllocator, pRenderPass);
      }
            void __attribute__ ((weak))
      lvp_CmdBeginRenderPass2(VkCommandBuffer commandBuffer, const VkRenderPassBeginInfo*      pRenderPassBegin, const VkSubpassBeginInfo*      pSubpassBeginInfo)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBeginRenderPass2(commandBuffer, pRenderPassBegin, pSubpassBeginInfo);
      }
            void __attribute__ ((weak))
      lvp_CmdNextSubpass2(VkCommandBuffer commandBuffer, const VkSubpassBeginInfo*      pSubpassBeginInfo, const VkSubpassEndInfo*        pSubpassEndInfo)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdNextSubpass2(commandBuffer, pSubpassBeginInfo, pSubpassEndInfo);
      }
            void __attribute__ ((weak))
      lvp_CmdEndRenderPass2(VkCommandBuffer commandBuffer, const VkSubpassEndInfo*        pSubpassEndInfo)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdEndRenderPass2(commandBuffer, pSubpassEndInfo);
      }
            VkResult __attribute__ ((weak))
      lvp_GetSemaphoreCounterValue(VkDevice device, VkSemaphore semaphore, uint64_t* pValue)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetSemaphoreCounterValue(device, semaphore, pValue);
      }
      VkResult __attribute__ ((weak))
      lvp_WaitSemaphores(VkDevice device, const VkSemaphoreWaitInfo* pWaitInfo, uint64_t timeout)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkWaitSemaphores(device, pWaitInfo, timeout);
      }
      VkResult __attribute__ ((weak))
      lvp_SignalSemaphore(VkDevice device, const VkSemaphoreSignalInfo* pSignalInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkSignalSemaphore(device, pSignalInfo);
      }
      void __attribute__ ((weak))
      lvp_CmdDrawIndirectCount(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, VkBuffer countBuffer, VkDeviceSize countBufferOffset, uint32_t maxDrawCount, uint32_t stride)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDrawIndirectCount(commandBuffer, buffer, offset, countBuffer, countBufferOffset, maxDrawCount, stride);
      }
            void __attribute__ ((weak))
      lvp_CmdDrawIndexedIndirectCount(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, VkBuffer countBuffer, VkDeviceSize countBufferOffset, uint32_t maxDrawCount, uint32_t stride)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDrawIndexedIndirectCount(commandBuffer, buffer, offset, countBuffer, countBufferOffset, maxDrawCount, stride);
      }
            void __attribute__ ((weak))
      lvp_CmdBindTransformFeedbackBuffersEXT(VkCommandBuffer commandBuffer, uint32_t firstBinding, uint32_t bindingCount, const VkBuffer* pBuffers, const VkDeviceSize* pOffsets, const VkDeviceSize* pSizes)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBindTransformFeedbackBuffersEXT(commandBuffer, firstBinding, bindingCount, pBuffers, pOffsets, pSizes);
      }
      void __attribute__ ((weak))
      lvp_CmdBeginTransformFeedbackEXT(VkCommandBuffer commandBuffer, uint32_t firstCounterBuffer, uint32_t counterBufferCount, const VkBuffer* pCounterBuffers, const VkDeviceSize* pCounterBufferOffsets)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBeginTransformFeedbackEXT(commandBuffer, firstCounterBuffer, counterBufferCount, pCounterBuffers, pCounterBufferOffsets);
      }
      void __attribute__ ((weak))
      lvp_CmdEndTransformFeedbackEXT(VkCommandBuffer commandBuffer, uint32_t firstCounterBuffer, uint32_t counterBufferCount, const VkBuffer* pCounterBuffers, const VkDeviceSize* pCounterBufferOffsets)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdEndTransformFeedbackEXT(commandBuffer, firstCounterBuffer, counterBufferCount, pCounterBuffers, pCounterBufferOffsets);
      }
      void __attribute__ ((weak))
      lvp_CmdBeginQueryIndexedEXT(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query, VkQueryControlFlags flags, uint32_t index)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdBeginQueryIndexedEXT(commandBuffer, queryPool, query, flags, index);
      }
      void __attribute__ ((weak))
      lvp_CmdEndQueryIndexedEXT(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query, uint32_t index)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdEndQueryIndexedEXT(commandBuffer, queryPool, query, index);
      }
      void __attribute__ ((weak))
      lvp_CmdDrawIndirectByteCountEXT(VkCommandBuffer commandBuffer, uint32_t instanceCount, uint32_t firstInstance, VkBuffer counterBuffer, VkDeviceSize counterBufferOffset, uint32_t counterOffset, uint32_t vertexStride)
      {
          LVP_FROM_HANDLE(lvp_cmd_buffer, lvp_cmd_buffer, commandBuffer);
          return lvp_cmd_buffer->device->dispatch.vkCmdDrawIndirectByteCountEXT(commandBuffer, instanceCount, firstInstance, counterBuffer, counterBufferOffset, counterOffset, vertexStride);
      }
      VkResult __attribute__ ((weak))
      lvp_GetRayTracingShaderGroupHandlesNV(VkDevice device, VkPipeline pipeline, uint32_t firstGroup, uint32_t groupCount, size_t dataSize, void* pData)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetRayTracingShaderGroupHandlesNV(device, pipeline, firstGroup, groupCount, dataSize, pData);
      }
      uint64_t __attribute__ ((weak))
      lvp_GetBufferOpaqueCaptureAddress(VkDevice device, const VkBufferDeviceAddressInfo* pInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetBufferOpaqueCaptureAddress(device, pInfo);
      }
      VkDeviceAddress __attribute__ ((weak))
      lvp_GetBufferDeviceAddress(VkDevice device, const VkBufferDeviceAddressInfo* pInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetBufferDeviceAddress(device, pInfo);
      }
            uint64_t __attribute__ ((weak))
      lvp_GetDeviceMemoryOpaqueCaptureAddress(VkDevice device, const VkDeviceMemoryOpaqueCaptureAddressInfo* pInfo)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetDeviceMemoryOpaqueCaptureAddress(device, pInfo);
      }
      VkResult __attribute__ ((weak))
      lvp_GetPipelineExecutablePropertiesKHR(VkDevice                        device, const VkPipelineInfoKHR*        pPipelineInfo, uint32_t* pExecutableCount, VkPipelineExecutablePropertiesKHR* pProperties)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetPipelineExecutablePropertiesKHR(device, pPipelineInfo, pExecutableCount, pProperties);
      }
      VkResult __attribute__ ((weak))
      lvp_GetPipelineExecutableStatisticsKHR(VkDevice                        device, const VkPipelineExecutableInfoKHR*  pExecutableInfo, uint32_t* pStatisticCount, VkPipelineExecutableStatisticKHR* pStatistics)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetPipelineExecutableStatisticsKHR(device, pExecutableInfo, pStatisticCount, pStatistics);
      }
      VkResult __attribute__ ((weak))
      lvp_GetPipelineExecutableInternalRepresentationsKHR(VkDevice                        device, const VkPipelineExecutableInfoKHR*  pExecutableInfo, uint32_t* pInternalRepresentationCount, VkPipelineExecutableInternalRepresentationKHR* pInternalRepresentations)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetPipelineExecutableInternalRepresentationsKHR(device, pExecutableInfo, pInternalRepresentationCount, pInternalRepresentations);
      }
      VkResult __attribute__ ((weak))
      lvp_CreatePrivateDataSlotEXT(VkDevice device, const VkPrivateDataSlotCreateInfoEXT* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkPrivateDataSlotEXT* pPrivateDataSlot)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkCreatePrivateDataSlotEXT(device, pCreateInfo, pAllocator, pPrivateDataSlot);
      }
      void __attribute__ ((weak))
      lvp_DestroyPrivateDataSlotEXT(VkDevice device, VkPrivateDataSlotEXT privateDataSlot, const VkAllocationCallbacks* pAllocator)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkDestroyPrivateDataSlotEXT(device, privateDataSlot, pAllocator);
      }
      VkResult __attribute__ ((weak))
      lvp_SetPrivateDataEXT(VkDevice device, VkObjectType objectType, uint64_t objectHandle, VkPrivateDataSlotEXT privateDataSlot, uint64_t data)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkSetPrivateDataEXT(device, objectType, objectHandle, privateDataSlot, data);
      }
      void __attribute__ ((weak))
      lvp_GetPrivateDataEXT(VkDevice device, VkObjectType objectType, uint64_t objectHandle, VkPrivateDataSlotEXT privateDataSlot, uint64_t* pData)
      {
          LVP_FROM_HANDLE(lvp_device, lvp_device, device);
          return lvp_device->dispatch.vkGetPrivateDataEXT(device, objectType, objectHandle, privateDataSlot, pData);
      }

  const struct lvp_device_dispatch_table lvp_device_dispatch_table = {
    .vkGetDeviceProcAddr = lvp_GetDeviceProcAddr,
    .vkDestroyDevice = lvp_DestroyDevice,
    .vkGetDeviceQueue = lvp_GetDeviceQueue,
    .vkQueueSubmit = lvp_QueueSubmit,
    .vkQueueWaitIdle = lvp_QueueWaitIdle,
    .vkDeviceWaitIdle = lvp_DeviceWaitIdle,
    .vkAllocateMemory = lvp_AllocateMemory,
    .vkFreeMemory = lvp_FreeMemory,
    .vkMapMemory = lvp_MapMemory,
    .vkUnmapMemory = lvp_UnmapMemory,
    .vkFlushMappedMemoryRanges = lvp_FlushMappedMemoryRanges,
    .vkInvalidateMappedMemoryRanges = lvp_InvalidateMappedMemoryRanges,
    .vkGetDeviceMemoryCommitment = lvp_GetDeviceMemoryCommitment,
    .vkGetBufferMemoryRequirements = lvp_GetBufferMemoryRequirements,
    .vkBindBufferMemory = lvp_BindBufferMemory,
    .vkGetImageMemoryRequirements = lvp_GetImageMemoryRequirements,
    .vkBindImageMemory = lvp_BindImageMemory,
    .vkGetImageSparseMemoryRequirements = lvp_GetImageSparseMemoryRequirements,
    .vkQueueBindSparse = lvp_QueueBindSparse,
    .vkCreateFence = lvp_CreateFence,
    .vkDestroyFence = lvp_DestroyFence,
    .vkResetFences = lvp_ResetFences,
    .vkGetFenceStatus = lvp_GetFenceStatus,
    .vkWaitForFences = lvp_WaitForFences,
    .vkCreateSemaphore = lvp_CreateSemaphore,
    .vkDestroySemaphore = lvp_DestroySemaphore,
    .vkCreateEvent = lvp_CreateEvent,
    .vkDestroyEvent = lvp_DestroyEvent,
    .vkGetEventStatus = lvp_GetEventStatus,
    .vkSetEvent = lvp_SetEvent,
    .vkResetEvent = lvp_ResetEvent,
    .vkCreateQueryPool = lvp_CreateQueryPool,
    .vkDestroyQueryPool = lvp_DestroyQueryPool,
    .vkGetQueryPoolResults = lvp_GetQueryPoolResults,
    .vkResetQueryPool = lvp_ResetQueryPool,
    .vkResetQueryPoolEXT = lvp_ResetQueryPool,
    .vkCreateBuffer = lvp_CreateBuffer,
    .vkDestroyBuffer = lvp_DestroyBuffer,
    .vkCreateBufferView = lvp_CreateBufferView,
    .vkDestroyBufferView = lvp_DestroyBufferView,
    .vkCreateImage = lvp_CreateImage,
    .vkDestroyImage = lvp_DestroyImage,
    .vkGetImageSubresourceLayout = lvp_GetImageSubresourceLayout,
    .vkCreateImageView = lvp_CreateImageView,
    .vkDestroyImageView = lvp_DestroyImageView,
    .vkCreateShaderModule = lvp_CreateShaderModule,
    .vkDestroyShaderModule = lvp_DestroyShaderModule,
    .vkCreatePipelineCache = lvp_CreatePipelineCache,
    .vkDestroyPipelineCache = lvp_DestroyPipelineCache,
    .vkGetPipelineCacheData = lvp_GetPipelineCacheData,
    .vkMergePipelineCaches = lvp_MergePipelineCaches,
    .vkCreateGraphicsPipelines = lvp_CreateGraphicsPipelines,
    .vkCreateComputePipelines = lvp_CreateComputePipelines,
    .vkDestroyPipeline = lvp_DestroyPipeline,
    .vkCreatePipelineLayout = lvp_CreatePipelineLayout,
    .vkDestroyPipelineLayout = lvp_DestroyPipelineLayout,
    .vkCreateSampler = lvp_CreateSampler,
    .vkDestroySampler = lvp_DestroySampler,
    .vkCreateDescriptorSetLayout = lvp_CreateDescriptorSetLayout,
    .vkDestroyDescriptorSetLayout = lvp_DestroyDescriptorSetLayout,
    .vkCreateDescriptorPool = lvp_CreateDescriptorPool,
    .vkDestroyDescriptorPool = lvp_DestroyDescriptorPool,
    .vkResetDescriptorPool = lvp_ResetDescriptorPool,
    .vkAllocateDescriptorSets = lvp_AllocateDescriptorSets,
    .vkFreeDescriptorSets = lvp_FreeDescriptorSets,
    .vkUpdateDescriptorSets = lvp_UpdateDescriptorSets,
    .vkCreateFramebuffer = lvp_CreateFramebuffer,
    .vkDestroyFramebuffer = lvp_DestroyFramebuffer,
    .vkCreateRenderPass = lvp_CreateRenderPass,
    .vkDestroyRenderPass = lvp_DestroyRenderPass,
    .vkGetRenderAreaGranularity = lvp_GetRenderAreaGranularity,
    .vkCreateCommandPool = lvp_CreateCommandPool,
    .vkDestroyCommandPool = lvp_DestroyCommandPool,
    .vkResetCommandPool = lvp_ResetCommandPool,
    .vkAllocateCommandBuffers = lvp_AllocateCommandBuffers,
    .vkFreeCommandBuffers = lvp_FreeCommandBuffers,
    .vkBeginCommandBuffer = lvp_BeginCommandBuffer,
    .vkEndCommandBuffer = lvp_EndCommandBuffer,
    .vkResetCommandBuffer = lvp_ResetCommandBuffer,
    .vkCmdBindPipeline = lvp_CmdBindPipeline,
    .vkCmdSetViewport = lvp_CmdSetViewport,
    .vkCmdSetScissor = lvp_CmdSetScissor,
    .vkCmdSetLineWidth = lvp_CmdSetLineWidth,
    .vkCmdSetDepthBias = lvp_CmdSetDepthBias,
    .vkCmdSetBlendConstants = lvp_CmdSetBlendConstants,
    .vkCmdSetDepthBounds = lvp_CmdSetDepthBounds,
    .vkCmdSetStencilCompareMask = lvp_CmdSetStencilCompareMask,
    .vkCmdSetStencilWriteMask = lvp_CmdSetStencilWriteMask,
    .vkCmdSetStencilReference = lvp_CmdSetStencilReference,
    .vkCmdBindDescriptorSets = lvp_CmdBindDescriptorSets,
    .vkCmdBindIndexBuffer = lvp_CmdBindIndexBuffer,
    .vkCmdBindVertexBuffers = lvp_CmdBindVertexBuffers,
    .vkCmdDraw = lvp_CmdDraw,
    .vkCmdDrawIndexed = lvp_CmdDrawIndexed,
    .vkCmdDrawIndirect = lvp_CmdDrawIndirect,
    .vkCmdDrawIndexedIndirect = lvp_CmdDrawIndexedIndirect,
    .vkCmdDispatch = lvp_CmdDispatch,
    .vkCmdDispatchIndirect = lvp_CmdDispatchIndirect,
    .vkCmdCopyBuffer = lvp_CmdCopyBuffer,
    .vkCmdCopyImage = lvp_CmdCopyImage,
    .vkCmdBlitImage = lvp_CmdBlitImage,
    .vkCmdCopyBufferToImage = lvp_CmdCopyBufferToImage,
    .vkCmdCopyImageToBuffer = lvp_CmdCopyImageToBuffer,
    .vkCmdUpdateBuffer = lvp_CmdUpdateBuffer,
    .vkCmdFillBuffer = lvp_CmdFillBuffer,
    .vkCmdClearColorImage = lvp_CmdClearColorImage,
    .vkCmdClearDepthStencilImage = lvp_CmdClearDepthStencilImage,
    .vkCmdClearAttachments = lvp_CmdClearAttachments,
    .vkCmdResolveImage = lvp_CmdResolveImage,
    .vkCmdSetEvent = lvp_CmdSetEvent,
    .vkCmdResetEvent = lvp_CmdResetEvent,
    .vkCmdWaitEvents = lvp_CmdWaitEvents,
    .vkCmdPipelineBarrier = lvp_CmdPipelineBarrier,
    .vkCmdBeginQuery = lvp_CmdBeginQuery,
    .vkCmdEndQuery = lvp_CmdEndQuery,
    .vkCmdBeginConditionalRenderingEXT = lvp_CmdBeginConditionalRenderingEXT,
    .vkCmdEndConditionalRenderingEXT = lvp_CmdEndConditionalRenderingEXT,
    .vkCmdResetQueryPool = lvp_CmdResetQueryPool,
    .vkCmdWriteTimestamp = lvp_CmdWriteTimestamp,
    .vkCmdCopyQueryPoolResults = lvp_CmdCopyQueryPoolResults,
    .vkCmdPushConstants = lvp_CmdPushConstants,
    .vkCmdBeginRenderPass = lvp_CmdBeginRenderPass,
    .vkCmdNextSubpass = lvp_CmdNextSubpass,
    .vkCmdEndRenderPass = lvp_CmdEndRenderPass,
    .vkCmdExecuteCommands = lvp_CmdExecuteCommands,
    .vkCreateSwapchainKHR = lvp_CreateSwapchainKHR,
    .vkDestroySwapchainKHR = lvp_DestroySwapchainKHR,
    .vkGetSwapchainImagesKHR = lvp_GetSwapchainImagesKHR,
    .vkAcquireNextImageKHR = lvp_AcquireNextImageKHR,
    .vkQueuePresentKHR = lvp_QueuePresentKHR,
    .vkCmdPushDescriptorSetKHR = lvp_CmdPushDescriptorSetKHR,
    .vkTrimCommandPool = lvp_TrimCommandPool,
    .vkTrimCommandPoolKHR = lvp_TrimCommandPool,
    .vkGetMemoryFdKHR = lvp_GetMemoryFdKHR,
    .vkGetMemoryFdPropertiesKHR = lvp_GetMemoryFdPropertiesKHR,
    .vkGetSemaphoreFdKHR = lvp_GetSemaphoreFdKHR,
    .vkImportSemaphoreFdKHR = lvp_ImportSemaphoreFdKHR,
    .vkGetFenceFdKHR = lvp_GetFenceFdKHR,
    .vkImportFenceFdKHR = lvp_ImportFenceFdKHR,
    .vkDisplayPowerControlEXT = lvp_DisplayPowerControlEXT,
    .vkRegisterDeviceEventEXT = lvp_RegisterDeviceEventEXT,
    .vkRegisterDisplayEventEXT = lvp_RegisterDisplayEventEXT,
    .vkGetSwapchainCounterEXT = lvp_GetSwapchainCounterEXT,
    .vkGetDeviceGroupPeerMemoryFeatures = lvp_GetDeviceGroupPeerMemoryFeatures,
    .vkGetDeviceGroupPeerMemoryFeaturesKHR = lvp_GetDeviceGroupPeerMemoryFeatures,
    .vkBindBufferMemory2 = lvp_BindBufferMemory2,
    .vkBindBufferMemory2KHR = lvp_BindBufferMemory2,
    .vkBindImageMemory2 = lvp_BindImageMemory2,
    .vkBindImageMemory2KHR = lvp_BindImageMemory2,
    .vkCmdSetDeviceMask = lvp_CmdSetDeviceMask,
    .vkCmdSetDeviceMaskKHR = lvp_CmdSetDeviceMask,
    .vkGetDeviceGroupPresentCapabilitiesKHR = lvp_GetDeviceGroupPresentCapabilitiesKHR,
    .vkGetDeviceGroupSurfacePresentModesKHR = lvp_GetDeviceGroupSurfacePresentModesKHR,
    .vkAcquireNextImage2KHR = lvp_AcquireNextImage2KHR,
    .vkCmdDispatchBase = lvp_CmdDispatchBase,
    .vkCmdDispatchBaseKHR = lvp_CmdDispatchBase,
    .vkCreateDescriptorUpdateTemplate = lvp_CreateDescriptorUpdateTemplate,
    .vkCreateDescriptorUpdateTemplateKHR = lvp_CreateDescriptorUpdateTemplate,
    .vkDestroyDescriptorUpdateTemplate = lvp_DestroyDescriptorUpdateTemplate,
    .vkDestroyDescriptorUpdateTemplateKHR = lvp_DestroyDescriptorUpdateTemplate,
    .vkUpdateDescriptorSetWithTemplate = lvp_UpdateDescriptorSetWithTemplate,
    .vkUpdateDescriptorSetWithTemplateKHR = lvp_UpdateDescriptorSetWithTemplate,
    .vkCmdPushDescriptorSetWithTemplateKHR = lvp_CmdPushDescriptorSetWithTemplateKHR,
    .vkCmdSetDiscardRectangleEXT = lvp_CmdSetDiscardRectangleEXT,
    .vkCmdSetSampleLocationsEXT = lvp_CmdSetSampleLocationsEXT,
    .vkGetBufferMemoryRequirements2 = lvp_GetBufferMemoryRequirements2,
    .vkGetBufferMemoryRequirements2KHR = lvp_GetBufferMemoryRequirements2,
    .vkGetImageMemoryRequirements2 = lvp_GetImageMemoryRequirements2,
    .vkGetImageMemoryRequirements2KHR = lvp_GetImageMemoryRequirements2,
    .vkGetImageSparseMemoryRequirements2 = lvp_GetImageSparseMemoryRequirements2,
    .vkGetImageSparseMemoryRequirements2KHR = lvp_GetImageSparseMemoryRequirements2,
    .vkCreateSamplerYcbcrConversion = lvp_CreateSamplerYcbcrConversion,
    .vkCreateSamplerYcbcrConversionKHR = lvp_CreateSamplerYcbcrConversion,
    .vkDestroySamplerYcbcrConversion = lvp_DestroySamplerYcbcrConversion,
    .vkDestroySamplerYcbcrConversionKHR = lvp_DestroySamplerYcbcrConversion,
    .vkGetDeviceQueue2 = lvp_GetDeviceQueue2,
    .vkGetDescriptorSetLayoutSupport = lvp_GetDescriptorSetLayoutSupport,
    .vkGetDescriptorSetLayoutSupportKHR = lvp_GetDescriptorSetLayoutSupport,
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkGetSwapchainGrallocUsageANDROID = lvp_GetSwapchainGrallocUsageANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkGetSwapchainGrallocUsage2ANDROID = lvp_GetSwapchainGrallocUsage2ANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkAcquireImageANDROID = lvp_AcquireImageANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkQueueSignalReleaseImageANDROID = lvp_QueueSignalReleaseImageANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
    .vkGetCalibratedTimestampsEXT = lvp_GetCalibratedTimestampsEXT,
    .vkGetMemoryHostPointerPropertiesEXT = lvp_GetMemoryHostPointerPropertiesEXT,
    .vkCreateRenderPass2 = lvp_CreateRenderPass2,
    .vkCreateRenderPass2KHR = lvp_CreateRenderPass2,
    .vkCmdBeginRenderPass2 = lvp_CmdBeginRenderPass2,
    .vkCmdBeginRenderPass2KHR = lvp_CmdBeginRenderPass2,
    .vkCmdNextSubpass2 = lvp_CmdNextSubpass2,
    .vkCmdNextSubpass2KHR = lvp_CmdNextSubpass2,
    .vkCmdEndRenderPass2 = lvp_CmdEndRenderPass2,
    .vkCmdEndRenderPass2KHR = lvp_CmdEndRenderPass2,
    .vkGetSemaphoreCounterValue = lvp_GetSemaphoreCounterValue,
    .vkWaitSemaphores = lvp_WaitSemaphores,
    .vkSignalSemaphore = lvp_SignalSemaphore,
    .vkCmdDrawIndirectCount = lvp_CmdDrawIndirectCount,
    .vkCmdDrawIndirectCountKHR = lvp_CmdDrawIndirectCount,
    .vkCmdDrawIndexedIndirectCount = lvp_CmdDrawIndexedIndirectCount,
    .vkCmdDrawIndexedIndirectCountKHR = lvp_CmdDrawIndexedIndirectCount,
    .vkCmdBindTransformFeedbackBuffersEXT = lvp_CmdBindTransformFeedbackBuffersEXT,
    .vkCmdBeginTransformFeedbackEXT = lvp_CmdBeginTransformFeedbackEXT,
    .vkCmdEndTransformFeedbackEXT = lvp_CmdEndTransformFeedbackEXT,
    .vkCmdBeginQueryIndexedEXT = lvp_CmdBeginQueryIndexedEXT,
    .vkCmdEndQueryIndexedEXT = lvp_CmdEndQueryIndexedEXT,
    .vkCmdDrawIndirectByteCountEXT = lvp_CmdDrawIndirectByteCountEXT,
    .vkGetRayTracingShaderGroupHandlesNV = lvp_GetRayTracingShaderGroupHandlesNV,
    .vkGetBufferOpaqueCaptureAddress = lvp_GetBufferOpaqueCaptureAddress,
    .vkGetBufferDeviceAddress = lvp_GetBufferDeviceAddress,
    .vkGetBufferDeviceAddressEXT = lvp_GetBufferDeviceAddress,
    .vkGetDeviceMemoryOpaqueCaptureAddress = lvp_GetDeviceMemoryOpaqueCaptureAddress,
    .vkGetPipelineExecutablePropertiesKHR = lvp_GetPipelineExecutablePropertiesKHR,
    .vkGetPipelineExecutableStatisticsKHR = lvp_GetPipelineExecutableStatisticsKHR,
    .vkGetPipelineExecutableInternalRepresentationsKHR = lvp_GetPipelineExecutableInternalRepresentationsKHR,
    .vkCreatePrivateDataSlotEXT = lvp_CreatePrivateDataSlotEXT,
    .vkDestroyPrivateDataSlotEXT = lvp_DestroyPrivateDataSlotEXT,
    .vkSetPrivateDataEXT = lvp_SetPrivateDataEXT,
    .vkGetPrivateDataEXT = lvp_GetPrivateDataEXT,
  };


/** Return true if the core version or extension in which the given entrypoint
 * is defined is enabled.
 *
 * If device is NULL, all device extensions are considered enabled.
 */
bool
lvp_instance_entrypoint_is_enabled(int index, uint32_t core_version,
                                   const struct lvp_instance_extension_table *instance)
{
   switch (index) {
   case 0:
      /* vkCreateInstance */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 1:
      /* vkDestroyInstance */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 2:
      /* vkEnumeratePhysicalDevices */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 3:
      /* vkGetInstanceProcAddr */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 4:
      /* vkEnumerateInstanceVersion */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 5:
      /* vkEnumerateInstanceLayerProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 6:
      /* vkEnumerateInstanceExtensionProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 7:
      /* vkCreateDisplayPlaneSurfaceKHR */
      if (instance->KHR_display) return true;
      return false;
   case 8:
      /* vkDestroySurfaceKHR */
      if (instance->KHR_surface) return true;
      return false;
   case 9:
      /* vkCreateWaylandSurfaceKHR */
      if (instance->KHR_wayland_surface) return true;
      return false;
   case 10:
      /* vkCreateXlibSurfaceKHR */
      if (instance->KHR_xlib_surface) return true;
      return false;
   case 11:
      /* vkCreateXcbSurfaceKHR */
      if (instance->KHR_xcb_surface) return true;
      return false;
   case 12:
      /* vkCreateDebugReportCallbackEXT */
      if (instance->EXT_debug_report) return true;
      return false;
   case 13:
      /* vkDestroyDebugReportCallbackEXT */
      if (instance->EXT_debug_report) return true;
      return false;
   case 14:
      /* vkDebugReportMessageEXT */
      if (instance->EXT_debug_report) return true;
      return false;
   case 15:
      /* vkEnumeratePhysicalDeviceGroups */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 16:
      /* vkEnumeratePhysicalDeviceGroupsKHR */
      if (instance->KHR_device_group_creation) return true;
      return false;
   default:
      return false;
   }
}

/** Return true if the core version or extension in which the given entrypoint
 * is defined is enabled.
 *
 * If device is NULL, all device extensions are considered enabled.
 */
bool
lvp_physical_device_entrypoint_is_enabled(int index, uint32_t core_version,
                                          const struct lvp_instance_extension_table *instance)
{
   switch (index) {
   case 0:
      /* vkGetPhysicalDeviceProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 1:
      /* vkGetPhysicalDeviceQueueFamilyProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 2:
      /* vkGetPhysicalDeviceMemoryProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 3:
      /* vkGetPhysicalDeviceFeatures */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 4:
      /* vkGetPhysicalDeviceFormatProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 5:
      /* vkGetPhysicalDeviceImageFormatProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 6:
      /* vkCreateDevice */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 7:
      /* vkEnumerateDeviceLayerProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 8:
      /* vkEnumerateDeviceExtensionProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 9:
      /* vkGetPhysicalDeviceSparseImageFormatProperties */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 10:
      /* vkGetPhysicalDeviceDisplayPropertiesKHR */
      if (instance->KHR_display) return true;
      return false;
   case 11:
      /* vkGetPhysicalDeviceDisplayPlanePropertiesKHR */
      if (instance->KHR_display) return true;
      return false;
   case 12:
      /* vkGetDisplayPlaneSupportedDisplaysKHR */
      if (instance->KHR_display) return true;
      return false;
   case 13:
      /* vkGetDisplayModePropertiesKHR */
      if (instance->KHR_display) return true;
      return false;
   case 14:
      /* vkCreateDisplayModeKHR */
      if (instance->KHR_display) return true;
      return false;
   case 15:
      /* vkGetDisplayPlaneCapabilitiesKHR */
      if (instance->KHR_display) return true;
      return false;
   case 16:
      /* vkGetPhysicalDeviceSurfaceSupportKHR */
      if (instance->KHR_surface) return true;
      return false;
   case 17:
      /* vkGetPhysicalDeviceSurfaceCapabilitiesKHR */
      if (instance->KHR_surface) return true;
      return false;
   case 18:
      /* vkGetPhysicalDeviceSurfaceFormatsKHR */
      if (instance->KHR_surface) return true;
      return false;
   case 19:
      /* vkGetPhysicalDeviceSurfacePresentModesKHR */
      if (instance->KHR_surface) return true;
      return false;
   case 20:
      /* vkGetPhysicalDeviceWaylandPresentationSupportKHR */
      if (instance->KHR_wayland_surface) return true;
      return false;
   case 21:
      /* vkGetPhysicalDeviceXlibPresentationSupportKHR */
      if (instance->KHR_xlib_surface) return true;
      return false;
   case 22:
      /* vkGetPhysicalDeviceXcbPresentationSupportKHR */
      if (instance->KHR_xcb_surface) return true;
      return false;
   case 23:
      /* vkGetPhysicalDeviceFeatures2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 24:
      /* vkGetPhysicalDeviceFeatures2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 25:
      /* vkGetPhysicalDeviceProperties2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 26:
      /* vkGetPhysicalDeviceProperties2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 27:
      /* vkGetPhysicalDeviceFormatProperties2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 28:
      /* vkGetPhysicalDeviceFormatProperties2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 29:
      /* vkGetPhysicalDeviceImageFormatProperties2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 30:
      /* vkGetPhysicalDeviceImageFormatProperties2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 31:
      /* vkGetPhysicalDeviceQueueFamilyProperties2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 32:
      /* vkGetPhysicalDeviceQueueFamilyProperties2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 33:
      /* vkGetPhysicalDeviceMemoryProperties2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 34:
      /* vkGetPhysicalDeviceMemoryProperties2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 35:
      /* vkGetPhysicalDeviceSparseImageFormatProperties2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 36:
      /* vkGetPhysicalDeviceSparseImageFormatProperties2KHR */
      if (instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 37:
      /* vkGetPhysicalDeviceExternalBufferProperties */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 38:
      /* vkGetPhysicalDeviceExternalBufferPropertiesKHR */
      if (instance->KHR_external_memory_capabilities) return true;
      return false;
   case 39:
      /* vkGetPhysicalDeviceExternalSemaphoreProperties */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 40:
      /* vkGetPhysicalDeviceExternalSemaphorePropertiesKHR */
      if (instance->KHR_external_semaphore_capabilities) return true;
      return false;
   case 41:
      /* vkGetPhysicalDeviceExternalFenceProperties */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 42:
      /* vkGetPhysicalDeviceExternalFencePropertiesKHR */
      if (instance->KHR_external_fence_capabilities) return true;
      return false;
   case 43:
      /* vkReleaseDisplayEXT */
      if (instance->EXT_direct_mode_display) return true;
      return false;
   case 44:
      /* vkAcquireXlibDisplayEXT */
      if (instance->EXT_acquire_xlib_display) return true;
      return false;
   case 45:
      /* vkGetRandROutputDisplayEXT */
      if (instance->EXT_acquire_xlib_display) return true;
      return false;
   case 46:
      /* vkGetPhysicalDeviceSurfaceCapabilities2EXT */
      if (instance->EXT_display_surface_counter) return true;
      return false;
   case 47:
      /* vkGetPhysicalDevicePresentRectanglesKHR */
      /* All device extensions are considered enabled at the instance level */
      return true;
      /* All device extensions are considered enabled at the instance level */
      return true;
      return false;
   case 48:
      /* vkGetPhysicalDeviceMultisamplePropertiesEXT */
      /* All device extensions are considered enabled at the instance level */
      return true;
      return false;
   case 49:
      /* vkGetPhysicalDeviceSurfaceCapabilities2KHR */
      if (instance->KHR_get_surface_capabilities2) return true;
      return false;
   case 50:
      /* vkGetPhysicalDeviceSurfaceFormats2KHR */
      if (instance->KHR_get_surface_capabilities2) return true;
      return false;
   case 51:
      /* vkGetPhysicalDeviceDisplayProperties2KHR */
      if (instance->KHR_get_display_properties2) return true;
      return false;
   case 52:
      /* vkGetPhysicalDeviceDisplayPlaneProperties2KHR */
      if (instance->KHR_get_display_properties2) return true;
      return false;
   case 53:
      /* vkGetDisplayModeProperties2KHR */
      if (instance->KHR_get_display_properties2) return true;
      return false;
   case 54:
      /* vkGetDisplayPlaneCapabilities2KHR */
      if (instance->KHR_get_display_properties2) return true;
      return false;
   case 55:
      /* vkGetPhysicalDeviceCalibrateableTimeDomainsEXT */
      /* All device extensions are considered enabled at the instance level */
      return true;
      return false;
   default:
      return false;
   }
}

/** Return true if the core version or extension in which the given entrypoint
 * is defined is enabled.
 *
 * If device is NULL, all device extensions are considered enabled.
 */
bool
lvp_device_entrypoint_is_enabled(int index, uint32_t core_version,
                                 const struct lvp_instance_extension_table *instance,
                                 const struct lvp_device_extension_table *device)
{
   switch (index) {
   case 0:
      /* vkGetDeviceProcAddr */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 1:
      /* vkDestroyDevice */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 2:
      /* vkGetDeviceQueue */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 3:
      /* vkQueueSubmit */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 4:
      /* vkQueueWaitIdle */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 5:
      /* vkDeviceWaitIdle */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 6:
      /* vkAllocateMemory */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 7:
      /* vkFreeMemory */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 8:
      /* vkMapMemory */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 9:
      /* vkUnmapMemory */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 10:
      /* vkFlushMappedMemoryRanges */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 11:
      /* vkInvalidateMappedMemoryRanges */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 12:
      /* vkGetDeviceMemoryCommitment */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 13:
      /* vkGetBufferMemoryRequirements */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 14:
      /* vkBindBufferMemory */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 15:
      /* vkGetImageMemoryRequirements */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 16:
      /* vkBindImageMemory */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 17:
      /* vkGetImageSparseMemoryRequirements */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 18:
      /* vkQueueBindSparse */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 19:
      /* vkCreateFence */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 20:
      /* vkDestroyFence */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 21:
      /* vkResetFences */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 22:
      /* vkGetFenceStatus */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 23:
      /* vkWaitForFences */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 24:
      /* vkCreateSemaphore */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 25:
      /* vkDestroySemaphore */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 26:
      /* vkCreateEvent */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 27:
      /* vkDestroyEvent */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 28:
      /* vkGetEventStatus */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 29:
      /* vkSetEvent */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 30:
      /* vkResetEvent */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 31:
      /* vkCreateQueryPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 32:
      /* vkDestroyQueryPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 33:
      /* vkGetQueryPoolResults */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 34:
      /* vkResetQueryPool */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 35:
      /* vkResetQueryPoolEXT */
      if (!device || device->EXT_host_query_reset) return true;
      return false;
   case 36:
      /* vkCreateBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 37:
      /* vkDestroyBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 38:
      /* vkCreateBufferView */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 39:
      /* vkDestroyBufferView */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 40:
      /* vkCreateImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 41:
      /* vkDestroyImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 42:
      /* vkGetImageSubresourceLayout */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 43:
      /* vkCreateImageView */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 44:
      /* vkDestroyImageView */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 45:
      /* vkCreateShaderModule */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 46:
      /* vkDestroyShaderModule */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 47:
      /* vkCreatePipelineCache */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 48:
      /* vkDestroyPipelineCache */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 49:
      /* vkGetPipelineCacheData */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 50:
      /* vkMergePipelineCaches */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 51:
      /* vkCreateGraphicsPipelines */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 52:
      /* vkCreateComputePipelines */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 53:
      /* vkDestroyPipeline */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 54:
      /* vkCreatePipelineLayout */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 55:
      /* vkDestroyPipelineLayout */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 56:
      /* vkCreateSampler */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 57:
      /* vkDestroySampler */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 58:
      /* vkCreateDescriptorSetLayout */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 59:
      /* vkDestroyDescriptorSetLayout */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 60:
      /* vkCreateDescriptorPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 61:
      /* vkDestroyDescriptorPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 62:
      /* vkResetDescriptorPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 63:
      /* vkAllocateDescriptorSets */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 64:
      /* vkFreeDescriptorSets */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 65:
      /* vkUpdateDescriptorSets */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 66:
      /* vkCreateFramebuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 67:
      /* vkDestroyFramebuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 68:
      /* vkCreateRenderPass */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 69:
      /* vkDestroyRenderPass */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 70:
      /* vkGetRenderAreaGranularity */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 71:
      /* vkCreateCommandPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 72:
      /* vkDestroyCommandPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 73:
      /* vkResetCommandPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 74:
      /* vkAllocateCommandBuffers */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 75:
      /* vkFreeCommandBuffers */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 76:
      /* vkBeginCommandBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 77:
      /* vkEndCommandBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 78:
      /* vkResetCommandBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 79:
      /* vkCmdBindPipeline */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 80:
      /* vkCmdSetViewport */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 81:
      /* vkCmdSetScissor */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 82:
      /* vkCmdSetLineWidth */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 83:
      /* vkCmdSetDepthBias */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 84:
      /* vkCmdSetBlendConstants */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 85:
      /* vkCmdSetDepthBounds */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 86:
      /* vkCmdSetStencilCompareMask */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 87:
      /* vkCmdSetStencilWriteMask */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 88:
      /* vkCmdSetStencilReference */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 89:
      /* vkCmdBindDescriptorSets */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 90:
      /* vkCmdBindIndexBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 91:
      /* vkCmdBindVertexBuffers */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 92:
      /* vkCmdDraw */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 93:
      /* vkCmdDrawIndexed */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 94:
      /* vkCmdDrawIndirect */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 95:
      /* vkCmdDrawIndexedIndirect */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 96:
      /* vkCmdDispatch */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 97:
      /* vkCmdDispatchIndirect */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 98:
      /* vkCmdCopyBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 99:
      /* vkCmdCopyImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 100:
      /* vkCmdBlitImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 101:
      /* vkCmdCopyBufferToImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 102:
      /* vkCmdCopyImageToBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 103:
      /* vkCmdUpdateBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 104:
      /* vkCmdFillBuffer */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 105:
      /* vkCmdClearColorImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 106:
      /* vkCmdClearDepthStencilImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 107:
      /* vkCmdClearAttachments */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 108:
      /* vkCmdResolveImage */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 109:
      /* vkCmdSetEvent */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 110:
      /* vkCmdResetEvent */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 111:
      /* vkCmdWaitEvents */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 112:
      /* vkCmdPipelineBarrier */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 113:
      /* vkCmdBeginQuery */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 114:
      /* vkCmdEndQuery */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 115:
      /* vkCmdBeginConditionalRenderingEXT */
      if (!device || device->EXT_conditional_rendering) return true;
      return false;
   case 116:
      /* vkCmdEndConditionalRenderingEXT */
      if (!device || device->EXT_conditional_rendering) return true;
      return false;
   case 117:
      /* vkCmdResetQueryPool */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 118:
      /* vkCmdWriteTimestamp */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 119:
      /* vkCmdCopyQueryPoolResults */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 120:
      /* vkCmdPushConstants */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 121:
      /* vkCmdBeginRenderPass */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 122:
      /* vkCmdNextSubpass */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 123:
      /* vkCmdEndRenderPass */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 124:
      /* vkCmdExecuteCommands */
      return VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 125:
      /* vkCreateSwapchainKHR */
      if (!device || device->KHR_swapchain) return true;
      return false;
   case 126:
      /* vkDestroySwapchainKHR */
      if (!device || device->KHR_swapchain) return true;
      return false;
   case 127:
      /* vkGetSwapchainImagesKHR */
      if (!device || device->KHR_swapchain) return true;
      return false;
   case 128:
      /* vkAcquireNextImageKHR */
      if (!device || device->KHR_swapchain) return true;
      return false;
   case 129:
      /* vkQueuePresentKHR */
      if (!device || device->KHR_swapchain) return true;
      return false;
   case 130:
      /* vkCmdPushDescriptorSetKHR */
      if (!device || device->KHR_push_descriptor) return true;
      return false;
   case 131:
      /* vkTrimCommandPool */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 132:
      /* vkTrimCommandPoolKHR */
      if (!device || device->KHR_maintenance1) return true;
      return false;
   case 133:
      /* vkGetMemoryFdKHR */
      if (!device || device->KHR_external_memory_fd) return true;
      return false;
   case 134:
      /* vkGetMemoryFdPropertiesKHR */
      if (!device || device->KHR_external_memory_fd) return true;
      return false;
   case 135:
      /* vkGetSemaphoreFdKHR */
      if (!device || device->KHR_external_semaphore_fd) return true;
      return false;
   case 136:
      /* vkImportSemaphoreFdKHR */
      if (!device || device->KHR_external_semaphore_fd) return true;
      return false;
   case 137:
      /* vkGetFenceFdKHR */
      if (!device || device->KHR_external_fence_fd) return true;
      return false;
   case 138:
      /* vkImportFenceFdKHR */
      if (!device || device->KHR_external_fence_fd) return true;
      return false;
   case 139:
      /* vkDisplayPowerControlEXT */
      if (!device || device->EXT_display_control) return true;
      return false;
   case 140:
      /* vkRegisterDeviceEventEXT */
      if (!device || device->EXT_display_control) return true;
      return false;
   case 141:
      /* vkRegisterDisplayEventEXT */
      if (!device || device->EXT_display_control) return true;
      return false;
   case 142:
      /* vkGetSwapchainCounterEXT */
      if (!device || device->EXT_display_control) return true;
      return false;
   case 143:
      /* vkGetDeviceGroupPeerMemoryFeatures */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 144:
      /* vkGetDeviceGroupPeerMemoryFeaturesKHR */
      if (!device || device->KHR_device_group) return true;
      return false;
   case 145:
      /* vkBindBufferMemory2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 146:
      /* vkBindBufferMemory2KHR */
      if (!device || device->KHR_bind_memory2) return true;
      return false;
   case 147:
      /* vkBindImageMemory2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 148:
      /* vkBindImageMemory2KHR */
      if (!device || device->KHR_bind_memory2) return true;
      return false;
   case 149:
      /* vkCmdSetDeviceMask */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 150:
      /* vkCmdSetDeviceMaskKHR */
      if (!device || device->KHR_device_group) return true;
      return false;
   case 151:
      /* vkGetDeviceGroupPresentCapabilitiesKHR */
      if (!device || device->KHR_swapchain) return true;
      if (!device || device->KHR_device_group) return true;
      return false;
   case 152:
      /* vkGetDeviceGroupSurfacePresentModesKHR */
      if (!device || device->KHR_swapchain) return true;
      if (!device || device->KHR_device_group) return true;
      return false;
   case 153:
      /* vkAcquireNextImage2KHR */
      if (!device || device->KHR_swapchain) return true;
      if (!device || device->KHR_device_group) return true;
      return false;
   case 154:
      /* vkCmdDispatchBase */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 155:
      /* vkCmdDispatchBaseKHR */
      if (!device || device->KHR_device_group) return true;
      return false;
   case 156:
      /* vkCreateDescriptorUpdateTemplate */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 157:
      /* vkCreateDescriptorUpdateTemplateKHR */
      if (!device || device->KHR_descriptor_update_template) return true;
      return false;
   case 158:
      /* vkDestroyDescriptorUpdateTemplate */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 159:
      /* vkDestroyDescriptorUpdateTemplateKHR */
      if (!device || device->KHR_descriptor_update_template) return true;
      return false;
   case 160:
      /* vkUpdateDescriptorSetWithTemplate */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 161:
      /* vkUpdateDescriptorSetWithTemplateKHR */
      if (!device || device->KHR_descriptor_update_template) return true;
      return false;
   case 162:
      /* vkCmdPushDescriptorSetWithTemplateKHR */
      if (!device || device->KHR_push_descriptor) return true;
      if (!device || device->KHR_push_descriptor) return true;
      if (!device || device->KHR_descriptor_update_template) return true;
      return false;
   case 163:
      /* vkCmdSetDiscardRectangleEXT */
      if (!device || device->EXT_discard_rectangles) return true;
      return false;
   case 164:
      /* vkCmdSetSampleLocationsEXT */
      if (!device || device->EXT_sample_locations) return true;
      return false;
   case 165:
      /* vkGetBufferMemoryRequirements2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 166:
      /* vkGetBufferMemoryRequirements2KHR */
      if (!device || device->KHR_get_memory_requirements2) return true;
      return false;
   case 167:
      /* vkGetImageMemoryRequirements2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 168:
      /* vkGetImageMemoryRequirements2KHR */
      if (!device || device->KHR_get_memory_requirements2) return true;
      return false;
   case 169:
      /* vkGetImageSparseMemoryRequirements2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 170:
      /* vkGetImageSparseMemoryRequirements2KHR */
      if (!device || device->KHR_get_memory_requirements2) return true;
      return false;
   case 171:
      /* vkCreateSamplerYcbcrConversion */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 172:
      /* vkCreateSamplerYcbcrConversionKHR */
      if (!device || device->KHR_sampler_ycbcr_conversion) return true;
      return false;
   case 173:
      /* vkDestroySamplerYcbcrConversion */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 174:
      /* vkDestroySamplerYcbcrConversionKHR */
      if (!device || device->KHR_sampler_ycbcr_conversion) return true;
      return false;
   case 175:
      /* vkGetDeviceQueue2 */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 176:
      /* vkGetDescriptorSetLayoutSupport */
      return VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 177:
      /* vkGetDescriptorSetLayoutSupportKHR */
      if (!device || device->KHR_maintenance3) return true;
      return false;
   case 178:
      /* vkGetSwapchainGrallocUsageANDROID */
      if (!device || device->ANDROID_native_buffer) return true;
      return false;
   case 179:
      /* vkGetSwapchainGrallocUsage2ANDROID */
      if (!device || device->ANDROID_native_buffer) return true;
      return false;
   case 180:
      /* vkAcquireImageANDROID */
      if (!device || device->ANDROID_native_buffer) return true;
      return false;
   case 181:
      /* vkQueueSignalReleaseImageANDROID */
      if (!device || device->ANDROID_native_buffer) return true;
      return false;
   case 182:
      /* vkGetCalibratedTimestampsEXT */
      if (!device || device->EXT_calibrated_timestamps) return true;
      return false;
   case 183:
      /* vkGetMemoryHostPointerPropertiesEXT */
      if (!device || device->EXT_external_memory_host) return true;
      return false;
   case 184:
      /* vkCreateRenderPass2 */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 185:
      /* vkCreateRenderPass2KHR */
      if (!device || device->KHR_create_renderpass2) return true;
      return false;
   case 186:
      /* vkCmdBeginRenderPass2 */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 187:
      /* vkCmdBeginRenderPass2KHR */
      if (!device || device->KHR_create_renderpass2) return true;
      return false;
   case 188:
      /* vkCmdNextSubpass2 */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 189:
      /* vkCmdNextSubpass2KHR */
      if (!device || device->KHR_create_renderpass2) return true;
      return false;
   case 190:
      /* vkCmdEndRenderPass2 */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 191:
      /* vkCmdEndRenderPass2KHR */
      if (!device || device->KHR_create_renderpass2) return true;
      return false;
   case 192:
      /* vkGetSemaphoreCounterValue */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 193:
      /* vkWaitSemaphores */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 194:
      /* vkSignalSemaphore */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 195:
      /* vkCmdDrawIndirectCount */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 196:
      /* vkCmdDrawIndirectCountKHR */
      if (!device || device->KHR_draw_indirect_count) return true;
      return false;
   case 197:
      /* vkCmdDrawIndexedIndirectCount */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 198:
      /* vkCmdDrawIndexedIndirectCountKHR */
      if (!device || device->KHR_draw_indirect_count) return true;
      return false;
   case 199:
      /* vkCmdBindTransformFeedbackBuffersEXT */
      if (!device || device->EXT_transform_feedback) return true;
      return false;
   case 200:
      /* vkCmdBeginTransformFeedbackEXT */
      if (!device || device->EXT_transform_feedback) return true;
      return false;
   case 201:
      /* vkCmdEndTransformFeedbackEXT */
      if (!device || device->EXT_transform_feedback) return true;
      return false;
   case 202:
      /* vkCmdBeginQueryIndexedEXT */
      if (!device || device->EXT_transform_feedback) return true;
      return false;
   case 203:
      /* vkCmdEndQueryIndexedEXT */
      if (!device || device->EXT_transform_feedback) return true;
      return false;
   case 204:
      /* vkCmdDrawIndirectByteCountEXT */
      if (!device || device->EXT_transform_feedback) return true;
      return false;
   case 205:
      /* vkGetRayTracingShaderGroupHandlesNV */
      return true;
   case 206:
      /* vkGetBufferOpaqueCaptureAddress */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 207:
      /* vkGetBufferDeviceAddress */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 208:
      /* vkGetBufferDeviceAddressEXT */
      if (!device || device->EXT_buffer_device_address) return true;
      return false;
   case 209:
      /* vkGetDeviceMemoryOpaqueCaptureAddress */
      return VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 210:
      /* vkGetPipelineExecutablePropertiesKHR */
      if (!device || device->KHR_pipeline_executable_properties) return true;
      return false;
   case 211:
      /* vkGetPipelineExecutableStatisticsKHR */
      if (!device || device->KHR_pipeline_executable_properties) return true;
      return false;
   case 212:
      /* vkGetPipelineExecutableInternalRepresentationsKHR */
      if (!device || device->KHR_pipeline_executable_properties) return true;
      return false;
   case 213:
      /* vkCreatePrivateDataSlotEXT */
      if (!device || device->EXT_private_data) return true;
      return false;
   case 214:
      /* vkDestroyPrivateDataSlotEXT */
      if (!device || device->EXT_private_data) return true;
      return false;
   case 215:
      /* vkSetPrivateDataEXT */
      if (!device || device->EXT_private_data) return true;
      return false;
   case 216:
      /* vkGetPrivateDataEXT */
      if (!device || device->EXT_private_data) return true;
      return false;
   default:
      return false;
   }
}

int
lvp_get_instance_entrypoint_index(const char *name)
{
   return instance_string_map_lookup(name);
}

int
lvp_get_physical_device_entrypoint_index(const char *name)
{
   return physical_device_string_map_lookup(name);
}

int
lvp_get_device_entrypoint_index(const char *name)
{
   return device_string_map_lookup(name);
}

const char *
lvp_get_instance_entry_name(int index)
{
   return instance_entry_name(index);
}

const char *
lvp_get_physical_device_entry_name(int index)
{
   return physical_device_entry_name(index);
}

const char *
lvp_get_device_entry_name(int index)
{
   return device_entry_name(index);
}

static void * __attribute__ ((noinline))
lvp_resolve_device_entrypoint(uint32_t index)
{
    return lvp_device_dispatch_table.entrypoints[index];
}

void *
lvp_lookup_entrypoint(const char *name)
{
   int idx = lvp_get_instance_entrypoint_index(name);
   if (idx >= 0)
      return lvp_instance_dispatch_table.entrypoints[idx];

   idx = lvp_get_physical_device_entrypoint_index(name);
   if (idx >= 0)
      return lvp_physical_device_dispatch_table.entrypoints[idx];

   idx = lvp_get_device_entrypoint_index(name);
   if (idx >= 0)
      return lvp_resolve_device_entrypoint(idx);

   return NULL;
}